/*
 * Intel ACPI Component Architecture
 * AML Disassembler version 20030109
 *
 * Disassembly of dsdt-06AE, Sat Mar  1 17:40:56 2003
 */
DefinitionBlock ("DSDT.aml", "DSDT", 1, "SEC   ", "SENS    ", 100925440)
{
    OperationRegion (PORT, SystemIO, 0x80, 0x01)
    Field (PORT, ByteAcc, NoLock, Preserve)
    {
        P80H,   8
    }

    OperationRegion (S_IO, SystemIO, 0x0600, 0x10)
    Field (S_IO, ByteAcc, NoLock, Preserve)
    {
        Offset (0x08), 
            ,   1, 
        ISPE,   1, 
        FPEN,   1, 
            ,   3, 
        SPEN,   1, 
        IPPE,   1
    }

    OperationRegion (A_IO, SystemIO, 0x1000, 0x30)
    Field (A_IO, ByteAcc, NoLock, Preserve)
    {
        PMS0,   8, 
        PMS1,   8, 
        PME0,   8, 
        PME1,   8, 
        PMC0,   8, 
        PMC1,   8, 
        Offset (0x08), 
        TMR0,   8, 
        TMR1,   8, 
        TMR2,   8, 
        TMR3,   8, 
        Offset (0x10), 
        PRC0,   8, 
        PRC1,   8, 
        PRC2,   8, 
        PRC3,   8, 
        Offset (0x28), 
        GPS0,   8, 
        GPS1,   8, 
        GPE0,   8, 
        GPE1,   8, 
        GPS2,   8, 
        GPS3,   8, 
        GPE2,   8, 
        GPE3,   8
    }

    OperationRegion (GPIO, SystemIO, 0x1180, 0x3C)
    Field (GPIO, ByteAcc, NoLock, Preserve)
    {
        GU00,   8, 
        GU01,   8, 
        GU02,   8, 
        GU03,   8, 
        GIO0,   8, 
        GIO1,   8, 
        GIO2,   8, 
        GIO3,   8, 
        Offset (0x0C), 
        GL00,   8, 
        GL01,   8, 
        GL02,   8, 
        GL03,   8, 
        Offset (0x18), 
        GB00,   8, 
        GB01,   8, 
        GB02,   8, 
        GB03,   8, 
        Offset (0x2C), 
        GIV0,   8, 
        GIV1,   8, 
        GIV2,   8, 
        GIV3,   8, 
        GU04,   8, 
        GU05,   8, 
        GU06,   8, 
        GU07,   8, 
        GIO4,   8, 
        GIO5,   8, 
        GIO6,   8, 
        GIO7,   8, 
            ,   1, 
            ,   1, 
        CPEN,   1, 
        GL05,   8, 
        GL06,   8, 
        GL07,   8
    }

    OperationRegion (MNVS, SystemMemory, 0x0FF7FD9D, 0x20)
    Field (MNVS, AnyAcc, Lock, Preserve)
    {
        OSYS,   16, 
        ACON,   8, 
        WRK0,   1, 
        WRK1,   1, 
        WRK2,   1, 
        Offset (0x04), 
        P4EN,   8, 
        Offset (0x08), 
        CMAP,   8, 
        CMBP,   8, 
        FDCP,   8, 
        LPTP,   8, 
        Offset (0x0D), 
        SW2S,   8, 
        SW2D,   8, 
        ADBG,   8, 
        ACTT,   8, 
        PSVT,   8, 
        TC1V,   8, 
        TC2V,   8, 
        TSPV,   8, 
        CRTT,   8, 
        Offset (0x18), 
        TMP0,   32, 
        TMP1,   32
    }

    Name (_S0, Package (0x03)
    {
        0x00, 
        0x00, 
        0x00
    })
    Name (_S3, Package (0x03)
    {
        0x05, 
        0x05, 
        0x00
    })
    Name (_S4, Package (0x03)
    {
        0x06, 
        0x06, 
        0x00
    })
    Name (_S5, Package (0x03)
    {
        0x07, 
        0x07, 
        0x00
    })
    Scope (\_PR)
    {
        Processor (CPU0, 0x00, 0x00001010, 0x06) {}
    }

    Name (\GPIC, 0x00)
    Name (\CTYP, 0x00)
    Name (\ECON, 0x00)
    Method (\_PIC, 1, NotSerialized)
    {
        Store (Arg0, GPIC)
    }

    Method (_PTS, 1, NotSerialized)
    {
        Store (Arg0, P80H)
        If (LEqual (Arg0, 0x03))
        {
            If (LNot (LGreater (OSYS, 0x07CF)))
            {
                \_SB.PHS (0xA7)
            }
        }
    }

    Method (_WAK, 1, NotSerialized)
    {
        Store (0x40, P80H)
        \_SB.PHS (0x80)
        Store (0x03, \_SB.BAT1.BCNT)
        If (LEqual (Arg0, 0x04))
        {
            Notify (\_SB.PWRB, 0x02)
        }

        If (LEqual (Arg0, 0x03))
        {
            If (LNot (LGreater (OSYS, 0x07CF)))
            {
                Notify (\_SB.PWRB, 0x02)
            }
        }

        Store (\_SB.PCI0.LPCB.H_EC.ACEX, ACON)
        If (LNot (LGreater (Arg0, 0x03)))
        {
            \_SB.PHS (0x9C)
        }

	Return(Zero)
    }

    Scope (\_GPE)
    {
        Method (_L05, 0, NotSerialized)
        {
            Notify (\_SB.PCI0.MODM, 0x02)
            Notify (\_SB.PWRB, 0x02)
        }

        Method (_L08, 0, NotSerialized)
        {
            Notify (\_SB.PCI0.LPCB.SIOD.COMA, 0x02)
        }

        Method (_L0B, 0, NotSerialized)
        {
            Notify (\_SB.PCI0, 0x02)
            Notify (\_SB.PCI0.PCIB, 0x02)
            Notify (\_SB.PWRB, 0x02)
        }

        Method (_L0C, 0, NotSerialized)
        {
            Notify (\_SB.PCI0.USB2, 0x02)
        }

        Method (_L1C, 0, NotSerialized)
        {
            Store (\_SB.PHS1 (0x98, 0x00), Local0)
            If (LEqual (Local0, 0x01))
            {
                Notify (\_SB.PWRB, 0x02)
            }

            If (LEqual (Local0, 0x03))
            {
                Notify (\_SB.PCI0.PCIB, 0x02)
            }

            If (LEqual (Local0, 0x04))
            {
                Notify (\_SB.PCI0.PCIB, 0x02)
            }

            If (LEqual (Local0, 0x05))
            {
                Notify (\_SB.PCI0.PCIB, 0x02)
            }
        }
    }

    Scope (\_TZ)
    {
        ThermalZone (THRM)
        {
            Method (_TMP, 0, NotSerialized)
            {
                If (LEqual (\ECON, 0x01))
                {
                    Store (\_SB.PCI0.LPCB.H_EC.CTMP, Local0)
                    If (LNot (LEqual (Local0, 0xFF)))
                    {
                        Multiply (Local0, 0x0A, Local0)
                        Add (Local0, 0x0AAC, Local0)
                        Return (Local0)
                    }
                }

                Return (0x0AF0)
            }

            Method (_AC0, 0, NotSerialized)
            {
                Store (0x41, Local0)
                Multiply (Local0, 0x0A, Local0)
                Add (Local0, 0x0AAC, Local0)
                Return (Local0)
            }

            Name (_AL0, Package (0x01)
            {
                FAN0
            })
            Method (XPSV, 0, NotSerialized)
            {
                Store (0x78, Local0)
                Multiply (Local0, 0x0A, Local0)
                Add (Local0, 0x0AAC, Local0)
                Return (Local0)
            }

            Name (XPSL, Package (0x01)
            {
                \_PR.CPU0
            })
            Method (_CRT, 0, NotSerialized)
            {
                Store (0x78, Local0)
                Multiply (Local0, 0x0A, Local0)
                Add (Local0, 0x0AAC, Local0)
                Return (Local0)
            }

            Method (_SCP, 1, NotSerialized)
            {
                Store ("Not Support", Debug)
            }

            Name (_TC1, 0x04)
            Name (_TC2, 0x03)
            Name (_TSP, 0x012C)
        }
    }

    PowerResource (PFAN, 0x00, 0x0000)
    {
        Method (_STA, 0, NotSerialized)
        {
            Return (FANE)
        }

        Method (_ON, 0, NotSerialized)
        {
            Store (0x01, FANE)
        }

        Method (_OFF, 0, NotSerialized)
        {
            Store (0x00, FANE)
        }
    }

    Name (FANE, 0x01)
    Device (FAN0)
    {
        Name (_HID, EisaId ("PNP0C0B"))
        Name (_PR0, Package (0x01)
        {
            PFAN
        })
    }

    Scope (\_SB)
    {
        OperationRegion (PHSD, SystemMemory, 0x0FF7FDBD, 0x00000190)
        Field (PHSD, AnyAcc, NoLock, Preserve)
        {
            BCMD,   8, 
            DID,    32, 
            INFO,   3152, 
            Offset (0x190)
        }

        Field (PHSD, AnyAcc, NoLock, Preserve)
        {
            Offset (0x05), 
            INF,    8, 
            INF1,   8, 
            INF2,   8, 
            INF3,   8
        }

        Field (PHSD, AnyAcc, NoLock, Preserve)
        {
            Offset (0x05), 
            INFW,   16
        }

        Field (PHSD, AnyAcc, NoLock, Preserve)
        {
            Offset (0x05), 
            INFD,   32
        }

        OperationRegion (PHSI, SystemIO, 0x0000FE00, 0x00000002)
        Field (PHSI, AnyAcc, NoLock, Preserve)
        {
            SMIC,   8
        }

        Mutex (MPHS, 0x00)
        Method (PHS, 1, Serialized)
        {
            Acquire (MPHS, 0xFFFF)
            Store (Arg0, BCMD)
            Store (Zero, SMIC)
            Store (0x00, BCMD)
            Store (INF, Local7)
            Release (MPHS)
            Return (Local7)
        }

        Method (PHSR, 1, Serialized)
        {
            Acquire (MPHS, 0xFFFF)
            Store (Arg0, BCMD)
            Store (Zero, SMIC)
            Store (0x00, BCMD)
            Store (INFD, Local7)
            Release (MPHS)
            Return (Local7)
        }

        Method (PHS1, 2, Serialized)
        {
            Acquire (MPHS, 0xFFFF)
            Store (Arg0, BCMD)
            Store (Arg1, INF)
            Store (Zero, SMIC)
            Store (0x00, BCMD)
            Store (INF, Local7)
            Release (MPHS)
            Return (Local7)
        }

        Method (PHS2, 3, Serialized)
        {
            Acquire (MPHS, 0xFFFF)
            Store (Arg0, BCMD)
            Store (Arg1, INF)
            Store (Arg2, INF1)
            Store (Zero, SMIC)
            Store (0x00, BCMD)
            Store (INFW, Local7)
            Release (MPHS)
            Return (Local7)
        }

        Method (PHS4, 5, Serialized)
        {
            Acquire (MPHS, 0xFFFF)
            Store (Arg0, BCMD)
            Store (Arg1, INF)
            Store (Arg2, INF1)
            Store (Arg3, INF2)
            Store (Arg4, INF3)
            Store (Zero, SMIC)
            Store (0x00, BCMD)
            Store (INFD, Local7)
            Release (MPHS)
            Return (Local7)
        }

        Device (ADP1)
        {
            Name (_HID, "ACPI0003")
            Method (_PSR, 0, NotSerialized)
            {
                If (LEqual (\ECON, 0x00))
                {
                    Store (\_SB.PHS1 (0x96, 0x02), Local0)
                }
                Else
                {
                    Store (\_SB.PCI0.LPCB.H_EC.ACEX, Local0)
                }

                Return (Local0)
            }

            Method (_PCL, 0, NotSerialized)
            {
                Return (\_SB)
            }

            Method (_STA, 0, NotSerialized)
            {
                If (LEqual (\ECON, 0x00))
                {
                    Store (0x0F, Local0)
                }
                Else
                {/*
                    If (LEqual (\_SB.PCI0.LPCB.H_EC.ACEX, 0x00))
                    {
                        Store (0x1F, Local0)
                    }
                    Else
                    {*/
                        Store (0x0F, Local0)
                    /*}*/
                }

                Return (Local0)
            }
        }

        Device (BAT1)
        {
            Name (_HID, EisaId ("PNP0C0A"))
            Name (_UID, 0x01)
            Name (TRPV, 0x00)
            Name (RMCP, 0x00)
            Name (BATI, Package (0x0D)
            {
                0x01, 
                0xFFFFFFFF, 
                0xFFFFFFFF, 
                0x00, 
                0xFFFFFFFF, 
                0x03, 
                0x0A, 
                0x01, 
                0x01, 
                "", 
                "", 
                "LION", 
                ""
            })
            Name (BTYP, Package (0x05)
            {
                "4S", 
                "4T", 
                "8D", 
                "3T", 
                ""
            })
            Name (BMAK, Package (0x04)
            {
                "SONY", 
                "Toshiba", 
                "SDI", 
                ""
            })
            Method (_BIF, 0, NotSerialized)
            {
                If (LEqual (\ECON, 0x00))
                {
                    Store (\_SB.PHS2 (0x9A, 0xB0, 0x00), Local0)
                    If (LEqual (Local0, 0xFFFF))
                    {
                        Store (0xFFFFFFFF, Index (BATI, 0x01))
                    }
                    Else
                    {
                        Store (Local0, Index (BATI, 0x01))
                    }

                    Store (\_SB.PHS2 (0x9A, 0xB2, 0x00), Local0)
                    If (LEqual (Local0, 0xFFFF))
                    {
                        Store (0xFFFFFFFF, Index (BATI, 0x02))
                    }
                    Else
                    {
                        Store (Local0, Index (BATI, 0x02))
                    }

                    Store (\_SB.PHS2 (0x9A, 0xB4, 0x00), Local0)
                    If (LEqual (Local0, 0xFFFF))
                    {
                        Store (0xFFFFFFFF, Index (BATI, 0x04))
                    }
                    Else
                    {
                        Store (Local0, Index (BATI, 0x04))
                    }

                    Store (0x00, Index (BATI, 0x05))
                    Store (\_SB.PHS2 (0x9A, 0xB6, 0x00), Local0)
                    If (LEqual (Local0, 0xFFFF))
                    {
                        Store (Zero, Index (BATI, 0x06))
                    }
                    Else
                    {
                        Store (0x00, Local0)
                        Store (Local0, Index (BATI, 0x06))
                    }

                    Store (\_SB.PHS2 (0x9A, 0xE0, 0x00), Local0)
                    If (LEqual (Local0, 0x5334))
                    {
                        Store (Zero, Local1)
                        Store (Zero, Local2)
                    }
                    Else
                    {
                        If (LEqual (Local0, 0x4438))
                        {
                            Store (0x02, Local1)
                            Store (0x02, Local2)
                        }
                        Else
                        {
                            If (LEqual (Local0, 0x5434))
                            {
                                Store (0x01, Local1)
                                Store (One, Local2)
                            }
                            Else
                            {
                                If (LEqual (Local0, 0x5433))
                                {
                                    Store (0x03, Local1)
                                    Store (One, Local2)
                                }
                                Else
                                {
                                    Store (0x04, Local1)
                                    Store (0x03, Local2)
                                }
                            }
                        }
                    }

                    Store (DerefOf (Index (BTYP, Local1)), Index (BATI, 0x09))
                    Store (DerefOf (Index (BMAK, Local2)), Index (BATI, 0x0C))
                }
                Else
                {
                    Store (\_SB.PCI0.LPCB.H_EC.B1DA, Local0)
                    ShiftLeft (Local0, 0x08, Local1)
                    And (Local1, 0xFF00, Local1)
                    ShiftRight (Local0, 0x08, Local0)
                    Or (Local0, Local1, Local0)
                    If (LEqual (Local0, 0xFFFF))
                    {
                        Store (0xFFFFFFFF, Index (BATI, 0x01))
                    }
                    Else
                    {
                        Store (Local0, Index (BATI, 0x01))
                    }

                    Store (\_SB.PCI0.LPCB.H_EC.B1DF, Local0)
                    ShiftLeft (Local0, 0x08, Local1)
                    And (Local1, 0xFF00, Local1)
                    ShiftRight (Local0, 0x08, Local0)
                    Or (Local0, Local1, Local0)
                    If (LEqual (Local0, 0xFFFF))
                    {
                        Store (0xFFFFFFFF, Index (BATI, 0x02))
                    }
                    Else
                    {
                        Store (Local0, Index (BATI, 0x02))
                    }

                    Store (\_SB.PCI0.LPCB.H_EC.B1DV, Local0)
                    ShiftLeft (Local0, 0x08, Local1)
                    And (Local1, 0xFF00, Local1)
                    ShiftRight (Local0, 0x08, Local0)
                    Or (Local0, Local1, Local0)
                    If (LEqual (Local0, 0xFFFF))
                    {
                        Store (0xFFFFFFFF, Index (BATI, 0x04))
                    }
                    Else
                    {
                        Store (Local0, Index (BATI, 0x04))
                    }

                    Store (0x00, Index (BATI, 0x05))
                    Store (\_SB.PCI0.LPCB.H_EC.B1DL, Local0)
                    ShiftLeft (Local0, 0x08, Local1)
                    And (Local1, 0xFF00, Local1)
                    ShiftRight (Local0, 0x08, Local0)
                    Or (Local0, Local1, Local0)
                    If (LEqual (Local0, 0xFFFF))
                    {
                        Store (0xFFFFFFFF, Index (BATI, 0x06))
                    }
                    Else
                    {
                        Store (0x00, Local0)
                        Store (Local0, Index (BATI, 0x06))
                    }

                    Store (\_SB.PCI0.LPCB.H_EC.B1NM, Local0)
                    If (LEqual (Local0, 0x5334))
                    {
                        Store (Zero, Local1)
                        Store (Zero, Local2)
                    }
                    Else
                    {
                        If (LEqual (Local0, 0x4438))
                        {
                            Store (0x02, Local1)
                            Store (0x02, Local2)
                        }
                        Else
                        {
                            If (LEqual (Local0, 0x5434))
                            {
                                Store (0x01, Local1)
                                Store (One, Local2)
                            }
                            Else
                            {
                                If (LEqual (Local0, 0x5433))
                                {
                                    Store (0x03, Local1)
                                    Store (One, Local2)
                                }
                                Else
                                {
                                    Store (0x04, Local1)
                                    Store (0x03, Local2)
                                }
                            }
                        }
                    }

                    Store (DerefOf (Index (BTYP, Local1)), Index (BATI, 0x09))
                    Store (DerefOf (Index (BMAK, Local2)), Index (BATI, 0x0C))
                }

                Return (BATI)
            }

            Name (STAT, Package (0x04)
            {
                0x00, 
                0x00, 
                0x00, 
                0x00
            })
            Method (_BTP, 1, NotSerialized)
            {
                Store (Arg0, TRPV)
            }

            Name (BCNT, 0x03)
            Method (BAST, 0, Serialized)
            {
                If (LEqual (\ECON, 0x00))
                {
                    Store (\_SB.PHS2 (0x99, 0x84, 0x00), Local0)
                    If (LAnd (LNot (LEqual (Local0, 0x00)), LNot (LEqual (Local0, 0x05))))
                    {
                        If (LEqual (\ACON, 0x01))
                        {
                            Store (0x02, Local0)
                        }
                        Else
                        {
                            Store (0x01, Local0)
                        }
                    }

                    Store (Local0, Index (STAT, 0x00))
                    Store (\_SB.PHS2 (0x9A, 0xD4, 0x00), Local0)
                    If (LEqual (Local0, 0xFFFF))
                    {
                        Store (0xFFFFFFFF, Index (STAT, 0x01))
                    }
                    Else
                    {
                        If (LNot (LLess (Local0, 0x8000)))
                        {
                            XOr (Local0, 0xFFFF, Local0)
                            Increment (Local0)
                        }

                        Store (Local0, Index (STAT, 0x01))
                    }

                    Store (\_SB.PHS2 (0x9A, 0xA2, 0x00), Local0)
                    If (LEqual (Local0, 0xFFFF))
                    {
                        Store (0xFFFFFFFF, Index (STAT, 0x02))
                        Store (0xFFFFFFFF, RMCP)
                    }
                    Else
                    {
                        Store (Local0, Index (STAT, 0x02))
                        Store (Local0, RMCP)
                    }

                    Store (\_SB.PHS2 (0x9A, 0xA6, 0x00), Local0)
                    If (LEqual (Local0, 0xFFFF))
                    {
                        Store (0xFFFFFFFF, Index (STAT, 0x03))
                    }
                    Else
                    {
                        Store (Local0, Index (STAT, 0x03))
                    }
                }
                Else
                {
                    Store (\_SB.PCI0.LPCB.H_EC.B1ST, Local0)
                    If (LAnd (LNot (LEqual (Local0, 0x00)), LNot (LEqual (Local0, 0x05))))
                    {
                        If (LEqual (\ACON, 0x01))
                        {
                            Store (0x02, Local0)
                        }
                        Else
                        {
                            Store (0x01, Local0)
                        }
                    }

                    Store (Local0, Index (STAT, 0x00))
                    Sleep (0x32)
                    Store (\_SB.PCI0.LPCB.H_EC.B1CR, Local0)
                    ShiftLeft (Local0, 0x08, Local1)
                    And (Local1, 0xFF00, Local1)
                    ShiftRight (Local0, 0x08, Local0)
                    Or (Local0, Local1, Local0)
                    If (LEqual (Local0, 0xFFFF))
                    {
                        Store (0xFFFFFFFF, Index (STAT, 0x01))
                    }
                    Else
                    {
                        If (LNot (LLess (Local0, 0x8000)))
                        {
                            XOr (Local0, 0xFFFF, Local0)
                            Increment (Local0)
                        }

                        Store (Local0, Index (STAT, 0x01))
                    }

                    Sleep (0x32)
                    Store (\_SB.PCI0.LPCB.H_EC.B1RA, Local0)
                    ShiftLeft (Local0, 0x08, Local1)
                    And (Local1, 0xFF00, Local1)
                    ShiftRight (Local0, 0x08, Local0)
                    Or (Local0, Local1, Local0)
                    If (LEqual (Local0, 0xFFFF))
                    {
                        Store (0xFFFFFFFF, Index (STAT, 0x02))
                        Store (0xFFFFFFFF, RMCP)
                    }
                    Else
                    {
                        Store (Local0, Index (STAT, 0x02))
                        Store (Local0, RMCP)
                    }

                    Sleep (0x32)
                    Store (\_SB.PCI0.LPCB.H_EC.B1VO, Local0)
                    ShiftLeft (Local0, 0x08, Local1)
                    And (Local1, 0xFF00, Local1)
                    ShiftRight (Local0, 0x08, Local0)
                    Or (Local0, Local1, Local0)
                    If (LEqual (Local0, 0xFFFF))
                    {
                        Store (0xFFFFFFFF, Index (STAT, 0x03))
                    }
                    Else
                    {
                        Store (Local0, Index (STAT, 0x03))
                    }

                    Sleep (0x32)
                }
            }

            Method (_BST, 0, NotSerialized)
            {
                If (LGreater (BCNT, Zero))
                {
                    BAST ()
                    Decrement (BCNT)
                    Sleep (0x32)
                }
                Else
                {
                    If (LEqual (\ECON, 0x00))
                    {
                        Store (\_SB.PHS2 (0x9A, 0xD4, 0x00), Local0)
                        If (LEqual (Local0, 0xFFFF))
                        {
                            Store (0xFFFFFFFF, Index (STAT, 0x01))
                        }
                        Else
                        {
                            If (LNot (LLess (Local0, 0x8000)))
                            {
                                XOr (Local0, 0xFFFF, Local0)
                                Increment (Local0)
                            }

                            Store (Local0, Index (STAT, 0x01))
                        }
                    }
                    Else
                    {
                        Store (\_SB.PCI0.LPCB.H_EC.B1CR, Local0)
                        ShiftLeft (Local0, 0x08, Local1)
                        And (Local1, 0xFF00, Local1)
                        ShiftRight (Local0, 0x08, Local0)
                        Or (Local0, Local1, Local0)
                        If (LEqual (Local0, 0xFFFF))
                        {
                            Store (0xFFFFFFFF, Index (STAT, 0x01))
                        }
                        Else
                        {
                            If (LNot (LLess (Local0, 0x8000)))
                            {
                                XOr (Local0, 0xFFFF, Local0)
                                Increment (Local0)
                            }

                            Store (Local0, Index (STAT, 0x01))
                        }
                    }

                    Sleep (0x32)
                }

                Return (STAT)
            }

            Method (_STA, 0, NotSerialized)
            {
                If (LEqual (\ECON, 0x00))
                {
                    If (LEqual (\_SB.PHS1 (0x96, 0x00), 0x01))
                    {
                        Store (0x1F, Local0)
                    }
                    Else
                    {
                        Store (0x0F, Local0)
                    }
                }
                Else
                {/*
                    If (LEqual (\_SB.PCI0.LPCB.H_EC.B1EX, 0x01))
                    {*/
                        Store (0x1F, Local0)
                    /*}
                    Else
                    {
                        Store (0x0F, Local0)
                    }*/
                }

                Return (Local0)
            }

            Method (_PCL, 0, NotSerialized)
            {
                Return (\_SB)
            }
        }

        Device (PWRB)
        {
            Name (_HID, EisaId ("PNP0C0C"))
            Name (_PRW, Package (0x02)
            {
                0x1C, 
                0x04
            })
        }

        Device (LID0)
        {
            Name (_HID, EisaId ("PNP0C0D"))
            Name (_PRW, Package (0x02)
            {
                0x1C, 
                0x03
            })
            Method (_STA, 0, NotSerialized)
            {
                Return (0x0F)
            }

            Method (_LID, 0, NotSerialized)
            {
                If (\ECON)
                {
                    If (LEqual (\_SB.PCI0.LPCB.H_EC.LIDS, 0x01))
                    {
                        Return (0x01)
                    }
                }

                Return (0x00)
            }
        }

        Device (SLPB)
        {
            Name (_HID, EisaId ("PNP0C0E"))
            Method (_STA, 0, NotSerialized)
            {
                Return (0x0F)
            }
        }

        Device (PCI0)
        {
            Method (_INI, 0, NotSerialized)
            {
                If (CondRefOf (_OSI, Local0))
                {
                    Store (0x07D1, OSYS)
                    \_SB.PHS (0xA5)
                }
                Else
                {
                    If (LEqual (SizeOf (_OS), 0x14))
                    {
                        Store (0x07D0, OSYS)
                        \_SB.PHS (0xA6)
                    }
                    Else
                    {
                        If (LEqual (SizeOf (_OS), 0x27))
                        {
                            Store (0x07CF, OSYS)
                            \_SB.PHS (0xA8)
                        }
                        Else
                        {
                            Store (0x07CE, OSYS)
                            \_SB.PHS (0xA9)
                        }
                    }
                }

                If (LNot (LGreater (OSYS, 0x07CF)))
                {
                    Store (0x01, ECON)
                    Store (0x00, TMP0)
                    If (LNot (LGreater (Zero, ACTT)))
                    {
                        Store (0x01, TMP0)
                    }

                    If (LEqual (0x00, ACTT))
                    {
                        Store (0x01, TMP0)
                    }

                    If (LEqual (TMP0, 0x01)) {}
                }
            }

            Method (_S1D, 0, NotSerialized)
            {
                Return (0x02)
            }

            Method (_S3D, 0, NotSerialized)
            {
                Return (0x03)
            }

            Method (_S4D, 0, NotSerialized)
            {
                Return (0x02)
            }

            Name (_HID, EisaId ("PNP0A03"))
            Name (_ADR, 0x00)
            Name (_BBN, 0x00)
            OperationRegion (HBUS, PCI_Config, 0x40, 0xC0)
            Field (HBUS, DWordAcc, NoLock, Preserve)
            {
                Offset (0x20), 
                DRB0,   8, 
                DRB1,   8, 
                DRB2,   8, 
                DRB3,   8, 
                DRB4,   8, 
                DRB5,   8, 
                DRB6,   8, 
                DRB7,   8, 
                Offset (0x50), 
                    ,   4, 
                PM0H,   2, 
                Offset (0x51), 
                PM1L,   2, 
                    ,   2, 
                PM1H,   2, 
                Offset (0x52), 
                PM2L,   2, 
                    ,   2, 
                PM2H,   2, 
                Offset (0x53), 
                PM3L,   2, 
                    ,   2, 
                PM3H,   2, 
                Offset (0x54), 
                PM4L,   2, 
                    ,   2, 
                PM4H,   2, 
                Offset (0x55), 
                PM5L,   2, 
                    ,   2, 
                PM5H,   2, 
                Offset (0x56), 
                PM6L,   2, 
                    ,   2, 
                PM6H,   2, 
                Offset (0x57), 
                FDHC,   8
            }

            Name (BUF0, ResourceTemplate ()
            {
                WordBusNumber (ResourceProducer, MinFixed, MaxFixed, PosDecode,
                    0x0000,
                    0x0000,
                    0x00FF,
                    0x0000,
                    0x0100, 0x00)
                DWordIO (ResourceProducer, MinFixed, MaxFixed, PosDecode, EntireRange,
                    0x00000000,
                    0x00000000,
                    0x00000CF7,
                    0x00000000,
                    0x00000CF8, 0x00)
                IO (Decode16, 0x0CF8, 0x0CF8, 0x01, 0x08)
                DWordIO (ResourceProducer, MinFixed, MaxFixed, PosDecode, EntireRange,
                    0x00000000,
                    0x00000D00,
                    0x0000FFFF,
                    0x00000000,
                    0x0000F300, 0x00)
                DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                    0x00000000,
                    0x000A0000,
                    0x000BFFFF,
                    0x00000000,
                    0x00020000, 0x00)
                DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                    0x00000000,
                    0x000C0000,
                    0x000C3FFF,
                    0x00000000,
                    0x00004000, 0x00)
                DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                    0x00000000,
                    0x000C4000,
                    0x000C7FFF,
                    0x00000000,
                    0x00004000, 0x00)
                DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                    0x00000000,
                    0x000C8000,
                    0x000CBFFF,
                    0x00000000,
                    0x00004000, 0x00)
                DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                    0x00000000,
                    0x000CC000,
                    0x000CFFFF,
                    0x00000000,
                    0x00004000, 0x00)
                DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                    0x00000000,
                    0x000D0000,
                    0x000D3FFF,
                    0x00000000,
                    0x00004000, 0x00)
                DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                    0x00000000,
                    0x000D4000,
                    0x000D7FFF,
                    0x00000000,
                    0x00004000, 0x00)
                DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                    0x00000000,
                    0x000D8000,
                    0x000DBFFF,
                    0x00000000,
                    0x00004000, 0x00)
                DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                    0x00000000,
                    0x000DC000,
                    0x000DFFFF,
                    0x00000000,
                    0x00004000, 0x00)
                DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                    0x00000000,
                    0x000E0000,
                    0x000E3FFF,
                    0x00000000,
                    0x00004000, 0x00)
                DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                    0x00000000,
                    0x000E4000,
                    0x000E7FFF,
                    0x00000000,
                    0x00004000, 0x00)
                DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                    0x00000000,
                    0x000E8000,
                    0x000EBFFF,
                    0x00000000,
                    0x00004000, 0x00)
                DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                    0x00000000,
                    0x000EC000,
                    0x000EFFFF,
                    0x00000000,
                    0x00004000, 0x00)
                DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                    0x00000000,
                    0x000F0000,
                    0x000FFFFF,
                    0x00000000,
                    0x00010000, 0x00)
                DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                    0x00000000,
                    0x00000000,
                    0xFEBFFFFF,
                    0x00000000,
                    0x00000000, 0x00)
            })
            Method (_CRS, 0, Serialized)
            {
                If (PM1L)
                {
                    CreateDWordField (BUF0, 0x80, C0LN)
                    Store (Zero, C0LN)
                }

                If (LEqual (PM1L, 0x01))
                {
                    CreateBitField (BUF0, 0x0378, C0RW)
                    Store (Zero, C0RW)
                }

                If (PM1H)
                {
                    CreateDWordField (BUF0, 0x9B, C4LN)
                    Store (Zero, C4LN)
                }

                If (LEqual (PM1H, 0x01))
                {
                    CreateBitField (BUF0, 0x0450, C4RW)
                    Store (Zero, C4RW)
                }

                If (PM2L)
                {
                    CreateDWordField (BUF0, 0xB6, C8LN)
                    Store (Zero, C8LN)
                }

                If (LEqual (PM2L, 0x01))
                {
                    CreateBitField (BUF0, 0x0528, C8RW)
                    Store (Zero, C8RW)
                }

                If (PM2H)
                {
                    CreateDWordField (BUF0, 0xD1, CCLN)
                    Store (Zero, CCLN)
                }

                If (LEqual (PM2H, 0x01))
                {
                    CreateBitField (BUF0, 0x0600, CCRW)
                    Store (Zero, CCRW)
                }

                If (PM3L)
                {
                    CreateDWordField (BUF0, 0xEC, D0LN)
                    Store (Zero, D0LN)
                }

                If (LEqual (PM3L, 0x01))
                {
                    CreateBitField (BUF0, 0x06D8, D0RW)
                    Store (Zero, D0RW)
                }

                If (PM3H)
                {
                    CreateDWordField (BUF0, 0x0107, D4LN)
                    Store (Zero, D4LN)
                }

                If (LEqual (PM3H, 0x01))
                {
                    CreateBitField (BUF0, 0x07B0, D4RW)
                    Store (Zero, D4RW)
                }

                If (PM4L)
                {
                    CreateDWordField (BUF0, 0x0122, D8LN)
                    Store (Zero, D8LN)
                }

                If (LEqual (PM4L, 0x01))
                {
                    CreateBitField (BUF0, 0x0888, D8RW)
                    Store (Zero, D8RW)
                }

                If (PM4H)
                {
                    CreateDWordField (BUF0, 0x013D, DCLN)
                    Store (Zero, DCLN)
                }

                If (LEqual (PM4H, 0x01))
                {
                    CreateBitField (BUF0, 0x0960, DCRW)
                    Store (Zero, DCRW)
                }

                If (PM5L)
                {
                    CreateDWordField (BUF0, 0x0158, E0LN)
                    Store (Zero, E0LN)
                }

                If (LEqual (PM5L, 0x01))
                {
                    CreateBitField (BUF0, 0x0A38, E0RW)
                    Store (Zero, E0RW)
                }

                If (PM5H)
                {
                    CreateDWordField (BUF0, 0x0173, E4LN)
                    Store (Zero, E4LN)
                }

                If (LEqual (PM5H, 0x01))
                {
                    CreateBitField (BUF0, 0x0B10, E4RW)
                    Store (Zero, E4RW)
                }

                If (PM6L)
                {
                    CreateDWordField (BUF0, 0x018E, E8LN)
                    Store (Zero, E8LN)
                }

                If (LEqual (PM6L, 0x01))
                {
                    CreateBitField (BUF0, 0x0BE8, E8RW)
                    Store (Zero, E8RW)
                }

                If (PM6H)
                {
                    CreateDWordField (BUF0, 0x01A9, ECLN)
                    Store (Zero, ECLN)
                }

                If (LEqual (PM6H, 0x01))
                {
                    CreateBitField (BUF0, 0x0CC0, ECRW)
                    Store (Zero, ECRW)
                }

                If (PM0H)
                {
                    CreateDWordField (BUF0, 0x01C4, F0LN)
                    Store (Zero, F0LN)
                }

                If (LEqual (PM0H, 0x01))
                {
                    CreateBitField (BUF0, 0x0D98, F0RW)
                    Store (Zero, F0RW)
                }

                CreateDWordField (BUF0, 0x01D3, M1MN)
                CreateDWordField (BUF0, 0x01D7, M1MX)
                CreateDWordField (BUF0, 0x01DF, M1LN)
                Multiply (0x02000000, DRB7, M1MN)
                Add (Subtract (M1MX, M1MN), 0x01, M1LN)
                Return (BUF0)
            }

            Method (_PRT, 0, NotSerialized)
            {
                If (GPIC)
                {
                    Return (Package (0x07)
                    {
                        Package (0x04)
                        {
                            0x0007FFFF, 
                            0x00, 
                            0x00, 
                            0x10
                        }, 

                        Package (0x04)
                        {
                            0x001DFFFF, 
                            0x00, 
                            0x00, 
                            0x10
                        }, 

                        Package (0x04)
                        {
                            0x001DFFFF, 
                            0x01, 
                            0x00, 
                            0x13
                        }, 

                        Package (0x04)
                        {
                            0x001DFFFF, 
                            0x02, 
                            0x00, 
                            0x12
                        }, 

                        Package (0x04)
                        {
                            0x001DFFFF, 
                            0x03, 
                            0x00, 
                            0x17
                        }, 

                        Package (0x04)
                        {
                            0x001FFFFF, 
                            0x00, 
                            0x00, 
                            0x12
                        }, 

                        Package (0x04)
                        {
                            0x001FFFFF, 
                            0x01, 
                            0x00, 
                            0x11
                        }
                    })
                }
                Else
                {
                    Return (Package (0x07)
                    {
                        Package (0x04)
                        {
                            0x0007FFFF, 
                            0x00, 
                            \_SB.PCI0.LPCB.LNKA, 
                            0x00
                        }, 

                        Package (0x04)
                        {
                            0x001DFFFF, 
                            0x00, 
                            \_SB.PCI0.LPCB.LNKA, 
                            0x00
                        }, 

                        Package (0x04)
                        {
                            0x001DFFFF, 
                            0x01, 
                            \_SB.PCI0.LPCB.LNKD, 
                            0x00
                        }, 

                        Package (0x04)
                        {
                            0x001DFFFF, 
                            0x02, 
                            \_SB.PCI0.LPCB.LNKC, 
                            0x00
                        }, 

                        Package (0x04)
                        {
                            0x001DFFFF, 
                            0x03, 
                            \_SB.PCI0.LPCB.LNKH, 
                            0x00
                        }, 

                        Package (0x04)
                        {
                            0x001FFFFF, 
                            0x00, 
                            \_SB.PCI0.LPCB.LNKC, 
                            0x00
                        }, 

                        Package (0x04)
                        {
                            0x001FFFFF, 
                            0x01, 
                            \_SB.PCI0.LPCB.LNKB, 
                            0x00
                        }
                    })
                }
            }

            Device (AGPB)
            {
                Name (_ADR, 0x00010000)
                Method (_PRT, 0, NotSerialized)
                {
                    If (GPIC)
                    {
                        Return (Package (0x02)
                        {
                            Package (0x04)
                            {
                                0xFFFF, 
                                0x00, 
                                0x00, 
                                0x10
                            }, 

                            Package (0x04)
                            {
                                0xFFFF, 
                                0x01, 
                                0x00, 
                                0x11
                            }
                        })
                    }
                    Else
                    {
                        Return (Package (0x02)
                        {
                            Package (0x04)
                            {
                                0xFFFF, 
                                0x00, 
                                \_SB.PCI0.LPCB.LNKA, 
                                0x00
                            }, 

                            Package (0x04)
                            {
                                0xFFFF, 
                                0x01, 
                                \_SB.PCI0.LPCB.LNKB, 
                                0x00
                            }
                        })
                    }
                }
            }

            Device (PCIB)
            {
                Name (_ADR, 0x001E0000)
                Device (LANC)
                {
                    Name (_ADR, 0x00080000)
                    Name (_PRW, Package (0x02)
                    {
                        0x0B, 
                        0x03
                    })
                }

                Device (CDB)
                {
                    Name (_ADR, 0x00030000)
                    OperationRegion (CBD0, PCI_Config, 0x00, 0xC0)
                    Field (CBD0, AnyAcc, NoLock, Preserve)
                    {
                        Offset (0x3C), 
                        CD3C,   8, 
                        Offset (0x44), 
                        CD44,   32, 
                        Offset (0xA5), 
                        CDA5,   8
                    }

                    Name (_PRW, Package (0x02)
                    {
                        0x0B, 
                        0x03
                    })
                    Method (_INI, 0, NotSerialized)
                    {
                        Or (CD3C, 0xFF, CD3C)
                    }

                    Method (_STA, 0, NotSerialized)
                    {
                        Return (0x0F)
                    }
                }

                Device (OHCI)
                {
                    Name (_ADR, 0x00030001)
                    Name (_PRW, Package (0x02)
                    {
                        0x0B, 
                        0x03
                    })
                    Method (_STA, 0, NotSerialized)
                    {
                        Return (0x0F)
                    }
                }

                Method (_PRT, 0, NotSerialized)
                {
                    If (GPIC)
                    {
                        Return (Package (0x05)
                        {
                            Package (0x04)
                            {
                                0x0003FFFF, 
                                0x00, 
                                0x00, 
                                0x10
                            }, 

                            Package (0x04)
                            {
                                0x0003FFFF, 
                                0x01, 
                                0x00, 
                                0x12
                            }, 

                            Package (0x04)
                            {
                                0x0008FFFF, 
                                0x00, 
                                0x00, 
                                0x14
                            }, 

                            Package (0x04)
                            {
                                0x0007FFFF, 
                                0x00, 
                                0x00, 
                                0x10
                            }, 

                            Package (0x04)
                            {
                                0x0007FFFF, 
                                0x01, 
                                0x00, 
                                0x11
                            }
                        })
                    }
                    Else
                    {
                        Return (Package (0x05)
                        {
                            Package (0x04)
                            {
                                0x0003FFFF, 
                                0x00, 
                                \_SB.PCI0.LPCB.LNKA, 
                                0x00
                            }, 

                            Package (0x04)
                            {
                                0x0003FFFF, 
                                0x01, 
                                \_SB.PCI0.LPCB.LNKC, 
                                0x00
                            }, 

                            Package (0x04)
                            {
                                0x0008FFFF, 
                                0x00, 
                                \_SB.PCI0.LPCB.LNKE, 
                                0x00
                            }, 

                            Package (0x04)
                            {
                                0x0007FFFF, 
                                0x00, 
                                \_SB.PCI0.LPCB.LNKA, 
                                0x00
                            }, 

                            Package (0x04)
                            {
                                0x0007FFFF, 
                                0x01, 
                                \_SB.PCI0.LPCB.LNKB, 
                                0x00
                            }
                        })
                    }
                }
            }

            Device (LPCB)
            {
                Name (_ADR, 0x001F0000)
                OperationRegion (LPC0, PCI_Config, 0x40, 0xC0)
                Field (LPC0, AnyAcc, NoLock, Preserve)
                {
                    Offset (0x20), 
                    PIRA,   8, 
                    PIRB,   8, 
                    PIRC,   8, 
                    PIRD,   8, 
                    Offset (0x28), 
                    PIRE,   8, 
                    PIRF,   8, 
                    PIRG,   8, 
                    PIRH,   8, 
                    Offset (0x90), 
                    MTSE,   32, 
                    CMAD,   3, 
                    Offset (0x95), 
                    LPAD,   2
                }

                Device (LNKA)
                {
                    Name (_HID, EisaId ("PNP0C0F"))
                    Name (_UID, 0x01)
                    Method (_DIS, 0, Serialized)
                    {
                        Store (0x80, PIRA)
                    }

                    Name (_PRS, ResourceTemplate ()
                    {
                        IRQ (Level, ActiveLow, Shared) {5}
                    })
                    Method (_CRS, 0, Serialized)
                    {
                        Name (RTLA, ResourceTemplate ()
                        {
                            IRQ (Level, ActiveLow, Shared) {}
                        })
                        CreateWordField (RTLA, 0x01, IRQ0)
                        Store (Zero, IRQ0)
                        ShiftLeft (0x01, And (PIRA, 0x0F), IRQ0)
                        Return (RTLA)
                    }

                    Method (_SRS, 1, Serialized)
                    {
                        CreateWordField (Arg0, 0x01, IRQ0)
                        FindSetRightBit (IRQ0, Local0)
                        Decrement (Local0)
                        Store (Local0, PIRA)
                    }

                    Method (_STA, 0, Serialized)
                    {
                        If (And (PIRA, 0x80))
                        {
                            Return (0x09)
                        }
                        Else
                        {
                            Return (0x0B)
                        }
                    }
                }

                Device (LNKB)
                {
                    Name (_HID, EisaId ("PNP0C0F"))
                    Name (_UID, 0x02)
                    Method (_DIS, 0, Serialized)
                    {
                        Store (0x80, PIRB)
                    }

                    Name (_PRS, ResourceTemplate ()
                    {
                        IRQ (Level, ActiveLow, Shared) {11}
                    })
                    Method (_CRS, 0, Serialized)
                    {
                        Name (RTLB, ResourceTemplate ()
                        {
                            IRQ (Level, ActiveLow, Shared) {}
                        })
                        CreateWordField (RTLB, 0x01, IRQ0)
                        Store (Zero, IRQ0)
                        ShiftLeft (0x01, And (PIRB, 0x0F), IRQ0)
                        Return (RTLB)
                    }

                    Method (_SRS, 1, Serialized)
                    {
                        CreateWordField (Arg0, 0x01, IRQ0)
                        FindSetRightBit (IRQ0, Local0)
                        Decrement (Local0)
                        Store (Local0, PIRB)
                    }

                    Method (_STA, 0, Serialized)
                    {
                        If (And (PIRB, 0x80))
                        {
                            Return (0x09)
                        }
                        Else
                        {
                            Return (0x0B)
                        }
                    }
                }

                Device (LNKC)
                {
                    Name (_HID, EisaId ("PNP0C0F"))
                    Name (_UID, 0x03)
                    Method (_DIS, 0, Serialized)
                    {
                        Store (0x80, PIRC)
                    }

                    Name (_PRS, ResourceTemplate ()
                    {
                        IRQ (Level, ActiveLow, Shared) {10}
                    })
                    Method (_CRS, 0, Serialized)
                    {
                        Name (RTLC, ResourceTemplate ()
                        {
                            IRQ (Level, ActiveLow, Shared) {}
                        })
                        CreateWordField (RTLC, 0x01, IRQ0)
                        Store (Zero, IRQ0)
                        ShiftLeft (0x01, And (PIRC, 0x0F), IRQ0)
                        Return (RTLC)
                    }

                    Method (_SRS, 1, Serialized)
                    {
                        CreateWordField (Arg0, 0x01, IRQ0)
                        FindSetRightBit (IRQ0, Local0)
                        Decrement (Local0)
                        Store (Local0, PIRC)
                    }

                    Method (_STA, 0, Serialized)
                    {
                        If (And (PIRC, 0x80))
                        {
                            Return (0x09)
                        }
                        Else
                        {
                            Return (0x0B)
                        }
                    }
                }

                Device (LNKD)
                {
                    Name (_HID, EisaId ("PNP0C0F"))
                    Name (_UID, 0x04)
                    Method (_DIS, 0, Serialized)
                    {
                        Store (0x80, PIRD)
                    }

                    Name (_PRS, ResourceTemplate ()
                    {
                        IRQ (Level, ActiveLow, Shared) {10}
                    })
                    Method (_CRS, 0, Serialized)
                    {
                        Name (RTLD, ResourceTemplate ()
                        {
                            IRQ (Level, ActiveLow, Shared) {}
                        })
                        CreateWordField (RTLD, 0x01, IRQ0)
                        Store (Zero, IRQ0)
                        ShiftLeft (0x01, And (PIRD, 0x0F), IRQ0)
                        Return (RTLD)
                    }

                    Method (_SRS, 1, Serialized)
                    {
                        CreateWordField (Arg0, 0x01, IRQ0)
                        FindSetRightBit (IRQ0, Local0)
                        Decrement (Local0)
                        Store (Local0, PIRD)
                    }

                    Method (_STA, 0, Serialized)
                    {
                        If (And (PIRD, 0x80))
                        {
                            Return (0x09)
                        }
                        Else
                        {
                            Return (0x0B)
                        }
                    }
                }

                Device (LNKE)
                {
                    Name (_HID, EisaId ("PNP0C0F"))
                    Name (_UID, 0x05)
                    Method (_DIS, 0, Serialized)
                    {
                        Store (0x80, PIRE)
                    }

                    Name (_PRS, ResourceTemplate ()
                    {
                        IRQ (Level, ActiveLow, Shared) {5}
                    })
                    Method (_CRS, 0, Serialized)
                    {
                        Name (RTLE, ResourceTemplate ()
                        {
                            IRQ (Level, ActiveLow, Shared) {}
                        })
                        CreateWordField (RTLE, 0x01, IRQ0)
                        Store (Zero, IRQ0)
                        ShiftLeft (0x01, And (PIRE, 0x0F), IRQ0)
                        Return (RTLE)
                    }

                    Method (_SRS, 1, Serialized)
                    {
                        CreateWordField (Arg0, 0x01, IRQ0)
                        FindSetRightBit (IRQ0, Local0)
                        Decrement (Local0)
                        Store (Local0, PIRE)
                    }

                    Method (_STA, 0, Serialized)
                    {
                        If (And (PIRE, 0x80))
                        {
                            Return (0x09)
                        }
                        Else
                        {
                            Return (0x0B)
                        }
                    }
                }

                Device (LNKF)
                {
                    Name (_HID, EisaId ("PNP0C0F"))
                    Name (_UID, 0x06)
                    Method (_DIS, 0, Serialized)
                    {
                        Store (0x80, PIRF)
                    }

                    Name (_PRS, ResourceTemplate ()
                    {
                        IRQ (Level, ActiveLow, Shared) {10}
                    })
                    Method (_CRS, 0, Serialized)
                    {
                        Name (RTLF, ResourceTemplate ()
                        {
                            IRQ (Level, ActiveLow, Shared) {}
                        })
                        CreateWordField (RTLF, 0x01, IRQ0)
                        Store (Zero, IRQ0)
                        ShiftLeft (0x01, And (PIRF, 0x0F), IRQ0)
                        Return (RTLF)
                    }

                    Method (_SRS, 1, Serialized)
                    {
                        CreateWordField (Arg0, 0x01, IRQ0)
                        FindSetRightBit (IRQ0, Local0)
                        Decrement (Local0)
                        Store (Local0, PIRF)
                    }

                    Method (_STA, 0, Serialized)
                    {
                        If (And (PIRF, 0x80))
                        {
                            Return (0x09)
                        }
                        Else
                        {
                            Return (0x0B)
                        }
                    }
                }

                Device (LNKG)
                {
                    Name (_HID, EisaId ("PNP0C0F"))
                    Name (_UID, 0x07)
                    Method (_DIS, 0, Serialized)
                    {
                        Store (0x80, PIRG)
                    }

                    Name (_PRS, ResourceTemplate ()
                    {
                        IRQ (Level, ActiveLow, Shared) {1,3,4,5,6,7,10,12,14,15}
                    })
                    Method (_CRS, 0, Serialized)
                    {
                        Name (RTLG, ResourceTemplate ()
                        {
                            IRQ (Level, ActiveLow, Shared) {}
                        })
                        CreateWordField (RTLG, 0x01, IRQ0)
                        Store (Zero, IRQ0)
                        ShiftLeft (0x01, And (PIRG, 0x0F), IRQ0)
                        Return (RTLG)
                    }

                    Method (_SRS, 1, Serialized)
                    {
                        CreateWordField (Arg0, 0x01, IRQ0)
                        FindSetRightBit (IRQ0, Local0)
                        Decrement (Local0)
                        Store (Local0, PIRF)
                    }

                    Method (_STA, 0, Serialized)
                    {
                        If (And (PIRG, 0x80))
                        {
                            Return (0x09)
                        }
                        Else
                        {
                            Return (0x0B)
                        }
                    }
                }

                Device (LNKH)
                {
                    Name (_HID, EisaId ("PNP0C0F"))
                    Name (_UID, 0x08)
                    Method (_DIS, 0, Serialized)
                    {
                        Store (0x80, PIRH)
                    }

                    Name (_PRS, ResourceTemplate ()
                    {
                        IRQ (Level, ActiveLow, Shared) {10}
                    })
                    Method (_CRS, 0, Serialized)
                    {
                        Name (RTLH, ResourceTemplate ()
                        {
                            IRQ (Level, ActiveLow, Shared) {}
                        })
                        CreateWordField (RTLH, 0x01, IRQ0)
                        Store (Zero, IRQ0)
                        ShiftLeft (0x01, And (PIRH, 0x0F), IRQ0)
                        Return (RTLH)
                    }

                    Method (_SRS, 1, Serialized)
                    {
                        CreateWordField (Arg0, 0x01, IRQ0)
                        FindSetRightBit (IRQ0, Local0)
                        Decrement (Local0)
                        Store (Local0, PIRH)
                    }

                    Method (_STA, 0, Serialized)
                    {
                        If (And (PIRH, 0x80))
                        {
                            Return (0x09)
                        }
                        Else
                        {
                            Return (0x0B)
                        }
                    }
                }

                Device (TIMR)
                {
                    Name (_HID, EisaId ("PNP0100"))
                    Name (BUF0, ResourceTemplate ()
                    {
                        IO (Decode16, 0x0040, 0x0040, 0x01, 0x04)
                        IO (Decode16, 0x0050, 0x0050, 0x10, 0x04)
                    })
                    Name (BUF1, ResourceTemplate ()
                    {
                        IO (Decode16, 0x0040, 0x0040, 0x01, 0x04)
                        IO (Decode16, 0x0050, 0x0050, 0x10, 0x04)
                        IRQNoFlags () {0}
                    })
                    Method (_CRS, 0, Serialized)
                    {
                        Return (BUF1)
                    }
                }

                Device (IPIC)
                {
                    Name (_HID, EisaId ("PNP0000"))
                    Name (_CRS, ResourceTemplate ()
                    {
                        IO (Decode16, 0x0020, 0x0020, 0x01, 0x02)
                        IO (Decode16, 0x0024, 0x0024, 0x01, 0x02)
                        IO (Decode16, 0x0028, 0x0028, 0x01, 0x02)
                        IO (Decode16, 0x002C, 0x002C, 0x01, 0x02)
                        IO (Decode16, 0x0030, 0x0030, 0x01, 0x02)
                        IO (Decode16, 0x0034, 0x0034, 0x01, 0x02)
                        IO (Decode16, 0x0038, 0x0038, 0x01, 0x02)
                        IO (Decode16, 0x003C, 0x003C, 0x01, 0x02)
                        IO (Decode16, 0x00A0, 0x00A0, 0x01, 0x02)
                        IO (Decode16, 0x00A4, 0x00A4, 0x01, 0x02)
                        IO (Decode16, 0x00A8, 0x00A8, 0x01, 0x02)
                        IO (Decode16, 0x00AC, 0x00AC, 0x01, 0x02)
                        IO (Decode16, 0x00B0, 0x00B0, 0x01, 0x02)
                        IO (Decode16, 0x00B4, 0x00B4, 0x01, 0x02)
                        IO (Decode16, 0x00B8, 0x00B8, 0x01, 0x02)
                        IO (Decode16, 0x00BC, 0x00BC, 0x01, 0x02)
                        IO (Decode16, 0x04D0, 0x04D0, 0x01, 0x02)
                        IRQNoFlags () {2}
                    })
                }

                Device (RTC)
                {
                    Name (_HID, EisaId ("PNP0B00"))
                    Name (BUF0, ResourceTemplate ()
                    {
                        IO (Decode16, 0x0070, 0x0070, 0x01, 0x08)
                    })
                    Name (BUF1, ResourceTemplate ()
                    {
                        IO (Decode16, 0x0070, 0x0070, 0x01, 0x08)
                        IRQNoFlags () {8}
                    })
                    Method (_CRS, 0, Serialized)
                    {
                        If (And (MTSE, 0x00020000))
                        {
                            Return (BUF0)
                        }

                        Return (BUF1)
                    }
                }

                Device (MATH)
                {
                    Name (_HID, EisaId ("PNP0C04"))
                    Name (_CRS, ResourceTemplate ()
                    {
                        IO (Decode16, 0x00F0, 0x00F0, 0x01, 0x01)
                        IRQNoFlags () {13}
                    })
                }

                Device (DMAC)
                {
                    Name (_HID, EisaId ("PNP0200"))
                    Name (_CRS, ResourceTemplate ()
                    {
                        IO (Decode16, 0x0000, 0x0000, 0x01, 0x20)
                        IO (Decode16, 0x0081, 0x0081, 0x01, 0x0F)
                        IO (Decode16, 0x0090, 0x0090, 0x01, 0x02)
                        IO (Decode16, 0x0093, 0x0093, 0x01, 0x0D)
                        IO (Decode16, 0x00C0, 0x00C0, 0x01, 0x20)
                        DMA (Compatibility, NotBusMaster, Transfer8_16) {4}
                    })
                }

                Device (MBRD)
                {
                    Name (_HID, EisaId ("PNP0C02"))
                    Name (_CRS, ResourceTemplate ()
                    {
                        IO (Decode16, 0x002E, 0x002E, 0x01, 0x02)
                        IO (Decode16, 0x0061, 0x0061, 0x01, 0x01)
                        IO (Decode16, 0x0063, 0x0063, 0x01, 0x01)
                        IO (Decode16, 0x0065, 0x0065, 0x01, 0x01)
                        IO (Decode16, 0x0067, 0x0067, 0x01, 0x01)
                        IO (Decode16, 0x0080, 0x0080, 0x01, 0x01)
                        IO (Decode16, 0x0092, 0x0092, 0x01, 0x01)
                        IO (Decode16, 0x0600, 0x0600, 0x01, 0x10)
                        IO (Decode16, 0x0700, 0x0700, 0x01, 0x10)
                        IO (Decode16, 0x1000, 0x1000, 0x01, 0x80)
                        IO (Decode16, 0x1180, 0x1180, 0x01, 0x40)
                        IO (Decode16, 0xFE00, 0xFE00, 0x01, 0x01)
                        IO (Decode16, 0x0580, 0x0580, 0x01, 0x08)
                        Memory32Fixed (ReadWrite, 0xFEBFFC00, 0x00000400)
                        Memory32Fixed (ReadWrite, 0xFED00000, 0x00004000)
                    })
                }

                Device (FWHD)
                {
                    Name (_HID, EisaId ("INT0800"))
                    Name (_CRS, ResourceTemplate ()
                    {
                        Memory32Fixed (ReadOnly, 0xFF800000, 0x00800000)
                    })
                }

                Device (H_EC)
                {
                    Name (_HID, EisaId ("PNP0C09"))
                    Method (_CRS, 0, NotSerialized)
                    {
                        Name (BFFR, ResourceTemplate ()
                        {
                            IO (Decode16, 0x0062, 0x0062, 0x00, 0x01)
                            IO (Decode16, 0x0066, 0x0066, 0x00, 0x01)
                        })
                        Return (BFFR)
                    }

                    Method (_REG, 2, NotSerialized)
                    {
                        If (LEqual (Arg0, 0x03))
                        {
                            If (LEqual (Arg1, 0x01))
                            {
                                Store (0x01, \ECON)
                                Store (\_SB.PHS1 (0x96, 0x02), Local0)
                                If (LEqual (Local0, 0x01))
                                {
                                    Store (0x01, ACON)
                                }
                                Else
                                {
                                    Store (0x00, ACON)
                                }
                            }
                            Else
                            {
                                Store (0x00, \ECON)
                            }
                        }
                    }

                    Name (_GPE, 0x18)
                    Event (EJT1)
                    OperationRegion (ECR, EmbeddedControl, 0x00, 0xFF)
                    Field (ECR, ByteAcc, Lock, Preserve)
                    {
                        Offset (0x80), 
                        B1EX,   1, 
                        B2EX,   1, 
                        ACEX,   1, 
                        Offset (0x81), 
                        SWBE,   1, 
                        DCBE,   1, 
                        Offset (0x82), 
                        RFON,   1, 
                        SPDI,   1, 
                        Offset (0x83), 
                        LIDS,   1, 
                        Offset (0x84), 
                        B1ST,   8, 
                        B2ST,   8, 
                        Offset (0xA0), 
                        B1RP,   16, 
                        B1RA,   16, 
                        B1PR,   16, 
                        B1VO,   16, 
                        B2RP,   16, 
                        B2RA,   16, 
                        B2PR,   16, 
                        B2VO,   16, 
                        B1DA,   16, 
                        B1DF,   16, 
                        B1DV,   16, 
                        B1DL,   16, 
                        B2DA,   16, 
                        B2DF,   16, 
                        B2DV,   16, 
                        B2DL,   16, 
                        CTMP,   8, 
                        Offset (0xD0), 
                        B1TI,   16, 
                        B1SE,   16, 
                        B1CR,   16, 
                        B1TM,   16, 
                        B2TI,   16, 
                        B2SE,   16, 
                        B2CR,   16, 
                        B2TM,   16, 
                        B1NM,   16, 
                        Offset (0xF0), 
                        B2NM,   16
                    }

                    Method (_Q50, 0, NotSerialized)
                    {
                        Notify (\_SB.PWRB, 0x80)
                    }

                    Method (_Q51, 0, NotSerialized)
                    {
                        Increment (\_SB.BAT1.BCNT)
                        \_SB.PHS (0xA1)
                        \_SB.PHS (0x9C)
                        Notify (\_SB.ADP1, 0x80)
                        Store (0x01, ACON)
                    }

                    Method (_Q52, 0, NotSerialized)
                    {
                        Increment (\_SB.BAT1.BCNT)
                        \_SB.PHS (0xA2)
                        \_SB.PHS (0x9C)
                        Notify (\_SB.ADP1, 0x80)
                        Store (0x00, ACON)
                    }

                    Method (_Q53, 0, NotSerialized)
                    {
                        Increment (\_SB.BAT1.BCNT)
                        Notify (\_SB.BAT1, 0x80)
                    }

                    Method (_Q54, 0, NotSerialized)
                    {
                        Increment (\_SB.BAT1.BCNT)
                        Notify (\_SB.BAT1, 0x80)
                    }

                    Method (_Q55, 0, NotSerialized)
                    {
                    }

                    Method (_Q56, 0, NotSerialized)
                    {
                    }

                    Method (_Q5B, 0, NotSerialized)
                    {
                        Notify (\_SB.SLPB, 0x80)
                    }

                    Method (_Q5C, 0, NotSerialized)
                    {
                        \_SB.PHS (0x94)
                    }

                    Method (_Q5D, 0, NotSerialized)
                    {
                        \_SB.PHS (0x95)
                    }

                    Method (_Q5E, 0, NotSerialized)
                    {
                        Notify (\_SB.LID0, 0x80)
                    }

                    Method (_Q5F, 0, NotSerialized)
                    {
                        Notify (\_SB.LID0, 0x80)
                    }

                    Method (_Q60, 0, NotSerialized)
                    {
                        If (LEqual (B1EX, 0x01))
                        {
                            \_SB.PHS (0x89)
                            Notify (\_SB.BAT1, 0x01)
                        }

                        If (LEqual (B2EX, 0x01))
                        {
                            \_SB.PHS (0x8A)
                        }
                    }

                    Method (_Q61, 0, NotSerialized)
                    {
                        If (LEqual (B1EX, 0x01))
                        {
                            \_SB.PHS (0x8B)
                            Notify (\_SB.BAT1, 0x01)
                        }

                        If (LEqual (B2EX, 0x01))
                        {
                            \_SB.PHS (0x8C)
                        }
                    }

                    Method (_Q65, 0, NotSerialized)
                    {
                        Notify (\_TZ.THRM, 0x80)
                    }

                    Method (_Q66, 0, NotSerialized)
                    {
                        Store (\_SB.BAT1.RMCP, Local1)
                        \_SB.BAT1.BAST ()
                        Sleep (0x32)
                        If (LNot (LEqual (\_SB.BAT1.TRPV, Zero)))
                        {
                            Store (\_SB.BAT1.RMCP, Local0)
                            Store (\_SB.BAT1.TRPV, Local2)
                            If (LLess (Local2, Local1))
                            {
                                If (LNot (LGreater (Local0, Local2)))
                                {
                                    Notify (\_SB.BAT1, 0x80)
                                }
                            }
                            Else
                            {
                                If (LNot (LLess (Local0, Local2)))
                                {
                                    Notify (\_SB.BAT1, 0x80)
                                }
                            }
                        }
                    }

                    Method (_Q67, 0, NotSerialized)
                    {
                    }

                    Method (_Q6C, 0, NotSerialized)
                    {
                        Increment (\_SB.BAT1.BCNT)
                        Notify (\_SB.ADP1, 0x80)
                        Notify (\_SB.BAT1, 0x80)
                    }
                }

                Device (SIOD)
                {
                    Name (_HID, EisaId ("PNP0A05"))
                    Method (DFIN, 0, NotSerialized)
                    {
                    }

                    OperationRegion (SIIO, SystemIO, 0x2E, 0x02)
                    Field (SIIO, ByteAcc, Lock, Preserve)
                    {
                        INDX,   8, 
                        DATA,   8
                    }

                    Mutex (MTIO, 0x00)
                    Name (CDEV, 0xFF)
                    Method (REGR, 2, NotSerialized)
                    {
                        Acquire (MTIO, 0xFFFF)
                        If (LNot (LEqual (CDEV, Arg0)))
                        {
                            Store (Arg0, CDEV)
                            Store (0x07, INDX)
                            Store (Arg0, DATA)
                        }

                        Store (Arg1, INDX)
                        Store (DATA, Local0)
                        Release (MTIO)
                        Return (Local0)
                    }

                    Method (REGW, 3, NotSerialized)
                    {
                        Acquire (MTIO, 0xFFFF)
                        If (LNot (LEqual (CDEV, Arg0)))
                        {
                            Store (Arg0, CDEV)
                            Store (0x07, INDX)
                            Store (Arg0, DATA)
                        }

                        Store (Arg1, INDX)
                        Store (Arg2, DATA)
                        Release (MTIO)
                    }

                    Method (STAT, 1, NotSerialized)
                    {
                        Acquire (MTIO, 0xFFFF)
                        Store (0x26, INDX)
                        And (DATA, Arg0, Local0)
                        Release (MTIO)
                        Return (XOr (Local0, Arg0))
                    }

                    Device (FDC)
                    {
                        Name (STOP, 0x00)
                        Name (_HID, EisaId ("PNP0700"))
                        Method (_STA, 0, NotSerialized)
                        {
                            If (STAT (0x01))
                            {
                                If (REGR (0x00, 0x30))
                                {
                                    Return (0x0F)
                                }
                                Else
                                {
                                    Return (0x0D)
                                }
                            }
                            Else
                            {
                                Return (0x00)
                            }
                        }

                        Method (_DIS, 0, NotSerialized)
                        {
                            Store ("===FDC _DIS===", Debug)
                            REGW (0x00, 0x30, 0x00)
                        }

                        Name (CRSA, ResourceTemplate ()
                        {
                            IO (Decode16, 0x03F0, 0x03F0, 0x01, 0x06)
                            IO (Decode16, 0x03F7, 0x03F7, 0x01, 0x01)
                            IRQNoFlags () {6}
                            DMA (Compatibility, NotBusMaster, Transfer8) {2}
                        })
                        Method (_CRS, 0, NotSerialized)
                        {
                            CreateWordField (CRSA, 0x02, MINA)
                            CreateWordField (CRSA, 0x04, MAXA)
                            CreateWordField (CRSA, 0x0A, MINB)
                            CreateWordField (CRSA, 0x0C, MAXB)
                            CreateWordField (CRSA, 0x11, INTA)
                            CreateByteField (CRSA, 0x14, DMAB)
                            If (REGR (0x00, 0x30))
                            {
                                Store (_PRS, CRSA)
                            }
                            Else
                            {
                                Store (Zero, MINA)
                                Store (Zero, MAXA)
                                Store (Zero, MINB)
                                Store (Zero, MAXB)
                                Store (Zero, INTA)
                                Store (Zero, DMAB)
                            }

                            Return (CRSA)
                        }

                        Name (_PRS, ResourceTemplate ()
                        {
                            IO (Decode16, 0x03F0, 0x03F0, 0x01, 0x06)
                            IO (Decode16, 0x03F7, 0x03F7, 0x01, 0x01)
                            IRQNoFlags () {6}
                            DMA (Compatibility, NotBusMaster, Transfer8) {2}
                        })
                        Method (_SRS, 1, NotSerialized)
                        {
                            Store (Arg0, CRSA)
                            CreateWordField (CRSA, 0x02, MINA)
                            CreateWordField (CRSA, 0x11, INTA)
                            CreateByteField (CRSA, 0x14, DMAB)
                            FindSetRightBit (INTA, Local0)
                            If (Local0)
                            {
                                Decrement (Local0)
                            }

                            REGW (0x00, 0x70, Local0)
                            FindSetRightBit (DMAB, Local0)
                            If (Local0)
                            {
                                Decrement (Local0)
                            }

                            REGW (0x00, 0x74, Local0)
                            ShiftRight (MINA, 0x08, Local0)
                            REGW (0x00, 0x60, Local0)
                            And (MINA, 0xFF, Local0)
                            REGW (0x00, 0x61, Local0)
                            REGW (0x00, 0x30, One)
                        }
                    }

                    Device (LPT)
                    {
                        Name (FLAG, 0xFF)
                        Name (_UID, 0x01)
                        Method (MODE, 0, NotSerialized)
                        {
                            If (LEqual (FLAG, 0xFF))
                            {
                                If (STAT (0x02))
                                {
                                    ShiftRight (REGR (0x01, 0xF0), 0x05, Local0)
                                    If (LOr (LEqual (Local0, 0x04), LEqual (Local0, 0x07)))
                                    {
                                        Store (0x02, FLAG)
                                    }
                                    Else
                                    {
                                        Store (0x01, FLAG)
                                    }
                                }
                                Else
                                {
                                    Store (0x00, FLAG)
                                }
                            }

                            Return (FLAG)
                        }

                        Method (_HID, 0, NotSerialized)
                        {
                            If (LEqual (MODE (), 0x02))
                            {
                                Return (0x0104D041)
                            }
                            Else
                            {
                                Return (0x0004D041)
                            }
                        }

                        Method (_STA, 0, NotSerialized)
                        {
                            If (LEqual (MODE (), 0x00))
                            {
                                Return (0x00)
                            }
                            Else
                            {
                                If (REGR (0x01, 0x30))
                                {
                                    Return (0x0F)
                                }
                                Else
                                {
                                    Return (0x0D)
                                }
                            }
                        }

                        Method (_DIS, 0, NotSerialized)
                        {
                            Store ("===LPT _DIS===", Debug)
                        }

                        Name (CRSA, ResourceTemplate ()
                        {
                            IO (Decode16, 0x0000, 0x0000, 0x01, 0x08)
                            IRQNoFlags () {}
                        })
                        Name (CRSB, ResourceTemplate ()
                        {
                            IO (Decode16, 0x0000, 0x0000, 0x01, 0x08)
                            IO (Decode16, 0x0000, 0x0000, 0x01, 0x08)
                            IRQNoFlags () {}
                            DMA (Compatibility, NotBusMaster, Transfer8) {}
                        })
                        Method (_CRS, 0, NotSerialized)
                        {
                            CreateWordField (CRSA, 0x02, MINA)
                            CreateWordField (CRSA, 0x04, MAXA)
                            CreateWordField (CRSA, 0x09, INTA)
                            Store (Zero, MINA)
                            Store (Zero, MAXA)
                            Store (Zero, INTA)
                            CreateWordField (CRSB, 0x02, MINB)
                            CreateWordField (CRSB, 0x04, MAXB)
                            CreateWordField (CRSB, 0x0A, MINC)
                            CreateWordField (CRSB, 0x0C, MAXC)
                            CreateWordField (CRSB, 0x11, INTB)
                            CreateByteField (CRSB, 0x14, DMAB)
                            Store (Zero, MINB)
                            Store (Zero, MAXB)
                            Store (Zero, MINC)
                            Store (Zero, MAXC)
                            Store (Zero, INTB)
                            Store (Zero, DMAB)
                            If (REGR (0x01, 0x30))
                            {
                                ShiftLeft (REGR (0x01, 0x60), 0x08, Local0)
                                Add (Local0, REGR (0x01, 0x61), Local0)
                                Store (Local0, MINA)
                                Store (Local0, MAXA)
                                Store (Local0, MINB)
                                Store (Local0, MAXB)
                                Add (Local0, 0x0400, Local0)
                                Store (Local0, MINC)
                                Store (Local0, MAXC)
                                And (REGR (0x01, 0x70), 0x0F, Local0)
                                If (Local0)
                                {
                                    ShiftLeft (One, Local0, Local0)
                                }

                                Store (Local0, INTA)
                                Store (Local0, INTB)
                                Store (REGR (0x01, 0x74), Local0)
                                If (LNot (LEqual (Local0, 0x04)))
                                {
                                    ShiftLeft (One, Local0, DMAB)
                                }
                            }

                            If (LEqual (MODE (), 0x02))
                            {
                                Return (CRSB)
                            }
                            Else
                            {
                                Return (CRSA)
                            }
                        }

                        Name (PRSA, ResourceTemplate ()
                        {
                            StartDependentFnNoPri ()
                            {
                                IO (Decode16, 0x0378, 0x0378, 0x01, 0x08)
                                IRQNoFlags () {5,7}
                            }
                            StartDependentFnNoPri ()
                            {
                                IO (Decode16, 0x0278, 0x0278, 0x01, 0x08)
                                IRQNoFlags () {5,7}
                            }
                            EndDependentFn ()
                        })
                        Name (PRSB, ResourceTemplate ()
                        {
                            StartDependentFnNoPri ()
                            {
                                IO (Decode16, 0x0378, 0x0378, 0x01, 0x08)
                                IO (Decode16, 0x0778, 0x0778, 0x01, 0x08)
                                IRQNoFlags () {5,7}
                                DMA (Compatibility, NotBusMaster, Transfer8) {0,1,2,3}
                            }
                            StartDependentFnNoPri ()
                            {
                                IO (Decode16, 0x0278, 0x0278, 0x01, 0x08)
                                IO (Decode16, 0x0678, 0x0678, 0x01, 0x08)
                                IRQNoFlags () {5,7}
                                DMA (Compatibility, NotBusMaster, Transfer8) {0,1,2,3}
                            }
                            EndDependentFn ()
                        })
                        Method (_PRS, 0, NotSerialized)
                        {
                            If (LEqual (MODE (), 0x02))
                            {
                                Return (PRSB)
                            }
                            Else
                            {
                                Return (PRSA)
                            }
                        }

                        Method (_SRS, 1, NotSerialized)
                        {
                            If (LEqual (MODE (), 0x02))
                            {
                                Store (Arg0, CRSB)
                                CreateWordField (CRSB, 0x02, MINB)
                                CreateWordField (CRSB, 0x11, INTB)
                                CreateByteField (CRSB, 0x14, DMAB)
                                FindSetRightBit (DMAB, Local0)
                                If (Local0)
                                {
                                    Decrement (Local0)
                                }
                                Else
                                {
                                    Store (0x04, Local0)
                                }

                                Store (MINB, Local1)
                                Store (INTB, Local2)
                            }
                            Else
                            {
                                Store (Arg0, CRSA)
                                CreateWordField (CRSA, 0x02, MINA)
                                CreateWordField (CRSA, 0x09, INTA)
                                Store (0x04, Local0)
                                Store (MINA, Local1)
                                Store (INTA, Local2)
                            }

                            REGW (0x01, 0x74, Local0)
                            ShiftRight (Local1, 0x08, Local0)
                            REGW (0x01, 0x60, Local0)
                            And (Local1, 0xFF, Local0)
                            REGW (0x01, 0x61, Local0)
                            FindSetRightBit (Local2, Local0)
                            If (Local0)
                            {
                                Decrement (Local0)
                            }

                            REGW (0x01, 0x70, Local0)
                            REGW (0x01, 0x30, 0x01)
                        }
                    }

                    Device (COMA)
                    {
                        Name (_HID, EisaId ("PNP0501"))
                        Name (_PSC, 0x00)
                        Name (FLGA, 0x00)
                        Method (_STA, 0, NotSerialized)
                        {
                            Store (0x00, Local0)
                            If (STAT (0x08))
                            {
                                If (REGR (0x03, 0x30))
                                {
                                    Store (0x0F, Local0)
                                }
                                Else
                                {
                                    Store (0x0D, Local0)
                                }
                            }
                            Return (Local0)
                        }

                        Method (_DIS, 0, NotSerialized)
                        {
                            Store ("===COMA _DIS===", Debug)
                        }

                        Name (CRSA, ResourceTemplate ()
                        {
                            IO (Decode16, 0x03F8, 0x03F8, 0x01, 0x08)
                            IRQNoFlags () {4}
                        })
                        Method (_CRS, 0, NotSerialized)
                        {
                            CreateWordField (CRSA, 0x02, MINA)
                            CreateWordField (CRSA, 0x04, MAXA)
                            CreateWordField (CRSA, 0x09, INTA)
                            If (REGR (0x03, 0x30))
                            {
                                ShiftLeft (REGR (0x03, 0x60), 0x08, Local0)
                                Add (Local0, REGR (0x03, 0x61), Local0)
                                Store (Local0, MINA)
                                Store (Local0, MAXA)
                                And (REGR (0x03, 0x70), 0x0F, Local0)
                                If (Local0)
                                {
                                    ShiftLeft (One, Local0, Local0)
                                }

                                Store (Local0, INTA)
                            }
                            Else
                            {
                                Store (Zero, MINA)
                                Store (Zero, MAXA)
                                Store (Zero, INTA)
                            }

                            Return (CRSA)
                        }

                        Name (_PRS, ResourceTemplate ()
                        {
                            StartDependentFnNoPri ()
                            {
                                IO (Decode16, 0x03F8, 0x03F8, 0x01, 0x08)
                                IRQNoFlags () {3,4}
                            }
                            StartDependentFnNoPri ()
                            {
                                IO (Decode16, 0x02F8, 0x02F8, 0x01, 0x08)
                                IRQNoFlags () {3,4}
                            }
                            StartDependentFnNoPri ()
                            {
                                IO (Decode16, 0x03E8, 0x03E8, 0x01, 0x08)
                                IRQNoFlags () {3,4}
                            }
                            StartDependentFnNoPri ()
                            {
                                IO (Decode16, 0x02E8, 0x02E8, 0x01, 0x08)
                                IRQNoFlags () {3,4}
                            }
                            EndDependentFn ()
                        })
                        Method (_SRS, 1, NotSerialized)
                        {
                            Store (Arg0, CRSA)
                            CreateWordField (CRSA, 0x02, MINX)
                            CreateWordField (CRSA, 0x09, INTX)
                            ShiftRight (MINX, 0x08, Local0)
                            REGW (0x03, 0x60, Local0)
                            And (MINX, 0xFF, Local0)
                            REGW (0x03, 0x61, Local0)
                            FindSetRightBit (INTX, Local0)
                            If (Local0)
                            {
                                Decrement (Local0)
                            }

                            REGW (0x03, 0x70, Local0)
                            REGW (0x03, 0x30, 0x01)
                        }

                        Method (_PS0, 0, NotSerialized)
                        {
                            Store ("===COMA _PS0===", Debug)
                            REGW (0x03, 0xF0, 0x82)
                            REGW (0x03, 0x30, 0x01)
                        }

                        Method (_PS3, 0, NotSerialized)
                        {
                            Store ("===COMA _PS3===", Debug)
                        }
                    }

                    Device (COMB)
                    {
                        Name (FLAG, 0xFF)
                        Name (_PSC, 0x00)
                        Name (_UID, 0x01)
                        Method (MODE, 0, NotSerialized)
                        {
                            If (LEqual (FLAG, 0xFF))
                            {
                                If (STAT (0x04))
                                {
                                    If (LEqual (REGR (0x02, 0x74), 0x04))
                                    {
                                        Store (0x03, FLAG)
                                    }
                                    Else
                                    {
                                        Store (0x04, FLAG)
                                    }
                                }
                                Else
                                {
                                    Store (0x00, FLAG)
                                }
                            }

                            Return (FLAG)
                        }

                        Method (_HID, 0, NotSerialized)
                        {
                            If (LEqual (MODE (), 0x04))
                            {
                                Return (0x0160633A)
                            }
                            Else
                            {
                                Return (0x1005D041)
                            }
                        }

                        Method (_STA, 0, NotSerialized)
                        {
                            If (LEqual (MODE (), 0x00))
                            {
                                Return (0x00)
                            }
                            Else
                            {
                                If (REGR (0x02, 0x30))
                                {
                                    Return (0x0F)
                                }
                                Else
                                {
                                    Return (0x0D)
                                }
                            }
                        }

                        Method (_DIS, 0, NotSerialized)
                        {
                            Store ("===COMB _DIS===", Debug)
                        }

                        Name (CRSA, ResourceTemplate ()
                        {
                            IO (Decode16, 0x0000, 0x0000, 0x01, 0x08)
                            IRQNoFlags () {}
                        })
                        Name (CRSB, ResourceTemplate ()
                        {
                            IO (Decode16, 0x0000, 0x0000, 0x01, 0x08)
                            IRQNoFlags () {}
                            DMA (Compatibility, NotBusMaster, Transfer8) {}
                        })
                        Method (_CRS, 0, NotSerialized)
                        {
                            CreateWordField (CRSA, 0x02, MINA)
                            CreateWordField (CRSA, 0x04, MAXA)
                            CreateWordField (CRSA, 0x09, INTA)
                            Store (Zero, MINA)
                            Store (Zero, MAXA)
                            Store (Zero, INTA)
                            CreateWordField (CRSB, 0x02, MINB)
                            CreateWordField (CRSB, 0x04, MAXB)
                            CreateWordField (CRSB, 0x09, INTB)
                            CreateByteField (CRSB, 0x0C, DMAB)
                            Store (Zero, MINB)
                            Store (Zero, MAXB)
                            Store (Zero, INTB)
                            Store (Zero, DMAB)
                            If (REGR (0x02, 0x30))
                            {
                                ShiftLeft (REGR (0x02, 0x60), 0x08, Local0)
                                Add (Local0, REGR (0x02, 0x61), Local0)
                                Store (Local0, MINA)
                                Store (Local0, MAXA)
                                Store (Local0, MINB)
                                Store (Local0, MAXB)
                                And (REGR (0x02, 0x70), 0x0F, Local0)
                                If (Local0)
                                {
                                    ShiftLeft (One, Local0, Local0)
                                }

                                Store (Local0, INTA)
                                Store (Local0, INTB)
                                Store (REGR (0x02, 0x74), Local0)
                                If (LNot (LEqual (Local0, 0x04)))
                                {
                                    ShiftLeft (One, Local0, DMAB)
                                }
                            }

                            If (LEqual (MODE (), 0x04))
                            {
                                Return (CRSB)
                            }
                            Else
                            {
                                Return (CRSA)
                            }
                        }

                        Name (PRSA, ResourceTemplate ()
                        {
                            StartDependentFnNoPri ()
                            {
                                IO (Decode16, 0x03F8, 0x03F8, 0x01, 0x08)
                                IRQNoFlags () {3,4}
                            }
                            StartDependentFnNoPri ()
                            {
                                IO (Decode16, 0x02F8, 0x02F8, 0x01, 0x08)
                                IRQNoFlags () {3,4}
                            }
                            StartDependentFnNoPri ()
                            {
                                IO (Decode16, 0x03E8, 0x03E8, 0x01, 0x08)
                                IRQNoFlags () {3,4}
                            }
                            StartDependentFnNoPri ()
                            {
                                IO (Decode16, 0x02E8, 0x02E8, 0x01, 0x08)
                                IRQNoFlags () {3,4}
                            }
                            EndDependentFn ()
                        })
                        Name (PRSB, ResourceTemplate ()
                        {
                            StartDependentFnNoPri ()
                            {
                                IO (Decode16, 0x03F8, 0x03F8, 0x01, 0x08)
                                IRQNoFlags () {3,4}
                                DMA (Compatibility, NotBusMaster, Transfer8) {0,1,2,3}
                            }
                            StartDependentFnNoPri ()
                            {
                                IO (Decode16, 0x02F8, 0x02F8, 0x01, 0x08)
                                IRQNoFlags () {3,4}
                                DMA (Compatibility, NotBusMaster, Transfer8) {0,1,2,3}
                            }
                            StartDependentFnNoPri ()
                            {
                                IO (Decode16, 0x03E8, 0x03E8, 0x01, 0x08)
                                IRQNoFlags () {3,4}
                                DMA (Compatibility, NotBusMaster, Transfer8) {0,1,2,3}
                            }
                            StartDependentFnNoPri ()
                            {
                                IO (Decode16, 0x02E8, 0x02E8, 0x01, 0x08)
                                IRQNoFlags () {3,4}
                                DMA (Compatibility, NotBusMaster, Transfer8) {0,1,2,3}
                            }
                            EndDependentFn ()
                        })
                        Method (_PRS, 0, NotSerialized)
                        {
                            If (LEqual (MODE (), 0x04))
                            {
                                Return (PRSB)
                            }
                            Else
                            {
                                Return (PRSA)
                            }
                        }

                        Method (_SRS, 1, NotSerialized)
                        {
                            If (LEqual (MODE (), 0x04))
                            {
                                Store (Arg0, CRSB)
                                CreateWordField (CRSB, 0x02, MINB)
                                CreateWordField (CRSB, 0x09, INTB)
                                CreateByteField (CRSB, 0x0C, DMAB)
                                FindSetRightBit (DMAB, Local0)
                                If (Local0)
                                {
                                    Decrement (Local0)
                                }
                                Else
                                {
                                    Store (0x04, Local0)
                                }

                                Store (MINB, Local1)
                                Store (INTB, Local2)
                            }
                            Else
                            {
                                Store (Arg0, CRSA)
                                CreateWordField (CRSA, 0x02, MINA)
                                CreateWordField (CRSA, 0x09, INTA)
                                Store (0x04, Local0)
                                Store (MINA, Local1)
                                Store (INTA, Local2)
                            }

                            REGW (0x02, 0x74, Local0)
                            ShiftRight (Local1, 0x08, Local0)
                            REGW (0x02, 0x60, Local0)
                            And (Local1, 0xFF, Local0)
                            REGW (0x02, 0x61, Local0)
                            FindSetRightBit (Local2, Local0)
                            If (Local0)
                            {
                                Decrement (Local0)
                            }

                            REGW (0x02, 0x70, Local0)
                            REGW (0x02, 0x30, 0x01)
                            If (LEqual (MODE (), 0x04))
                            {
                                Or (REGR (0x02, 0xF0), 0x80, Local0)
                                REGW (0x02, 0xF0, Local0)
                            }
                        }

                        Method (_PS0, 0, NotSerialized)
                        {
                            Store ("===COMB _PS0===", Debug)
                            REGW (0x02, 0xF0, 0x82)
                            REGW (0x02, 0x30, 0x01)
                        }

                        Method (_PS3, 0, NotSerialized)
                        {
                            Store ("===COMB _PS3===", Debug)
                        }
                    }
                }

                Device (PS2K)
                {
                    Name (_HID, EisaId ("PNP0303"))
                    Name (_CRS, ResourceTemplate ()
                    {
                        IO (Decode16, 0x0060, 0x0060, 0x01, 0x01)
                        IO (Decode16, 0x0064, 0x0064, 0x01, 0x01)
                        IRQ (Edge, ActiveHigh, Exclusive) {1}
                    })
                }

                Device (PS2M)
                {
                    Name (_HID, EisaId ("PNP0F13"))
                    Name (_CRS, ResourceTemplate ()
                    {
                        IRQ (Edge, ActiveHigh, Exclusive) {12}
                    })
                }
            }

            Device (USB0)
            {
                Name (_ADR, 0x001D0000)
                OperationRegion (U0CS, PCI_Config, 0xC4, 0x04)
                Field (U0CS, DWordAcc, NoLock, Preserve)
                {
                    U0EN,   2
                }

                Method (_PSW, 1, NotSerialized)
                {
                    If (Arg0)
                    {
                        Store (0x03, U0EN)
                    }
                    Else
                    {
                        Store (0x00, U0EN)
                    }
                }

                Method (_S1D, 0, NotSerialized)
                {
                    Return (0x02)
                }

                Method (_S3D, 0, NotSerialized)
                {
                    Return (0x03)
                }

                Method (_S4D, 0, NotSerialized)
                {
                    Return (0x02)
                }
            }

            Device (USB1)
            {
                Name (_ADR, 0x001D0001)
                OperationRegion (U1CS, PCI_Config, 0xC4, 0x04)
                Field (U1CS, DWordAcc, NoLock, Preserve)
                {
                    U1EN,   2
                }

                Method (_PSW, 1, NotSerialized)
                {
                    If (Arg0)
                    {
                        Store (0x03, U1EN)
                    }
                    Else
                    {
                        Store (0x00, U1EN)
                    }
                }

                Method (_S1D, 0, NotSerialized)
                {
                    Return (0x02)
                }

                Method (_S3D, 0, NotSerialized)
                {
                    Return (0x03)
                }

                Method (_S4D, 0, NotSerialized)
                {
                    Return (0x02)
                }
            }

            Device (USB2)
            {
                Name (_ADR, 0x001D0002)
                OperationRegion (U2CS, PCI_Config, 0xC4, 0x04)
                Field (U2CS, DWordAcc, NoLock, Preserve)
                {
                    U2EN,   2
                }

                Method (_PSW, 1, NotSerialized)
                {
                    If (Arg0)
                    {
                        Store (0x03, U2EN)
                    }
                    Else
                    {
                        Store (0x00, U2EN)
                    }
                }

                Method (_S1D, 0, NotSerialized)
                {
                    Return (0x02)
                }

                Method (_S3D, 0, NotSerialized)
                {
                    Return (0x03)
                }

                Method (_S4D, 0, NotSerialized)
                {
                    Return (0x02)
                }
            }

            Name (PAUL, Package (0x01)
            {
                0x001F0001
            })
            Device (IDEC)
            {
                Name (_ADR, 0x001F0001)
                OperationRegion (IDEC, PCI_Config, 0x40, 0x18)
                Field (IDEC, DWordAcc, NoLock, Preserve)
                {
                    PRIT,   16, 
                    SECT,   16, 
                    PSIT,   4, 
                    SSIT,   4, 
                    Offset (0x08), 
                    SYNC,   4, 
                    Offset (0x0A), 
                    SDT0,   2, 
                        ,   2, 
                    SDT1,   2, 
                    Offset (0x0B), 
                    SDT2,   2, 
                        ,   2, 
                    SDT3,   2, 
                    Offset (0x14), 
                    ICR0,   4, 
                    ICR1,   4, 
                    ICR2,   4, 
                    ICR3,   4, 
                    ICR4,   4, 
                    ICR5,   4
                }

                Device (PRID)
                {
                    Name (_ADR, 0x00)
                    Method (_GTM, 0, NotSerialized)
                    {
                        Name (PBUF, Buffer (0x14)
                        {
                            0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                            0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                            0x00, 0x00, 0x00, 0x00
                        })
                        CreateDWordField (PBUF, 0x00, PIO0)
                        CreateDWordField (PBUF, 0x04, DMA0)
                        CreateDWordField (PBUF, 0x08, PIO1)
                        CreateDWordField (PBUF, 0x0C, DMA1)
                        CreateDWordField (PBUF, 0x10, FLAG)
                        Store (GETP (PRIT), PIO0)
                        Store (GDMA (And (SYNC, 0x01), And (ICR3, 0x01), And (ICR0, 0x01), SDT0, And (ICR1, 0x01)), DMA0)
                        If (LEqual (DMA0, 0xFFFFFFFF))
                        {
                            Store (PIO0, DMA0)
                        }

                        If (And (PRIT, 0x4000))
                        {
                            If (LEqual (And (PRIT, 0x90), 0x80))
                            {
                                Store (0x0384, PIO1)
                            }
                            Else
                            {
                                Store (GETT (PSIT), PIO1)
                            }
                        }
                        Else
                        {
                            Store (0xFFFFFFFF, PIO1)
                        }

                        Store (GDMA (And (SYNC, 0x02), And (ICR3, 0x02), And (ICR0, 0x02), SDT1, And (ICR1, 0x02)), DMA1)
                        If (LEqual (DMA1, 0xFFFFFFFF))
                        {
                            Store (PIO1, DMA1)
                        }

                        Store (GETF (And (SYNC, 0x01), And (SYNC, 0x02), PRIT), FLAG)
                        Return (PBUF)
                    }

                    Method (_STM, 3, NotSerialized)
                    {
                        CreateDWordField (Arg0, 0x00, PIO0)
                        CreateDWordField (Arg0, 0x04, DMA0)
                        CreateDWordField (Arg0, 0x08, PIO1)
                        CreateDWordField (Arg0, 0x0C, DMA1)
                        CreateDWordField (Arg0, 0x10, FLAG)
                        Store (0x04, ICR2)
                        If (LEqual (SizeOf (Arg1), 0x0200))
                        {
                            And (PRIT, 0x40F0, PRIT)
                            And (SYNC, 0x0E, SYNC)
                            Store (0x00, SDT0)
                            And (ICR0, 0x0E, ICR0)
                            And (ICR1, 0x0E, ICR1)
                            And (ICR3, 0x0E, ICR3)
                            And (ICR5, 0x0E, ICR5)
                            CreateWordField (Arg1, 0x62, W490)
                            CreateWordField (Arg1, 0x6A, W530)
                            CreateWordField (Arg1, 0x7E, W630)
                            CreateWordField (Arg1, 0x80, W640)
                            CreateWordField (Arg1, 0xB0, W880)
                            CreateWordField (Arg1, 0xBA, W930)
                            Or (PRIT, 0x8004, PRIT)
                            If (LAnd (And (FLAG, 0x02), And (W490, 0x0800)))
                            {
                                Or (PRIT, 0x02, PRIT)
                            }

                            Or (PRIT, SETP (PIO0, W530, W640), PRIT)
                            If (And (FLAG, 0x01))
                            {
                                Or (SYNC, 0x01, SYNC)
                                Store (SDMA (DMA0), SDT0)
                                If (LLess (DMA0, 0x1E))
                                {
                                    Or (ICR3, 0x01, ICR3)
                                }

                                If (LLess (DMA0, 0x3C))
                                {
                                    Or (ICR0, 0x01, ICR0)
                                }

                                If (And (W930, 0x2000))
                                {
                                    Or (ICR1, 0x01, ICR1)
                                }
                            }
                        }

                        If (LEqual (SizeOf (Arg2), 0x0200))
                        {
                            And (PRIT, 0x3F0F, PRIT)
                            Store (0x00, PSIT)
                            And (SYNC, 0x0D, SYNC)
                            Store (0x00, SDT1)
                            And (ICR0, 0x0D, ICR0)
                            And (ICR1, 0x0D, ICR1)
                            And (ICR3, 0x0D, ICR3)
                            And (ICR5, 0x0D, ICR5)
                            CreateWordField (Arg2, 0x62, W491)
                            CreateWordField (Arg2, 0x6A, W531)
                            CreateWordField (Arg2, 0x7E, W631)
                            CreateWordField (Arg2, 0x80, W641)
                            CreateWordField (Arg2, 0xB0, W881)
                            CreateWordField (Arg2, 0xBA, W931)
                            Or (PRIT, 0x8040, PRIT)
                            If (LAnd (And (FLAG, 0x08), And (W491, 0x0800)))
                            {
                                Or (PRIT, 0x20, PRIT)
                            }

                            If (And (FLAG, 0x10))
                            {
                                Or (PRIT, 0x4000, PRIT)
                                If (LGreater (PIO1, 0xF0))
                                {
                                    Or (PRIT, 0x80, PRIT)
                                }
                                Else
                                {
                                    Or (PRIT, 0x10, PRIT)
                                    Store (SETT (PIO1, W531, W641), PSIT)
                                }
                            }

                            If (And (FLAG, 0x04))
                            {
                                Or (SYNC, 0x02, SYNC)
                                Store (SDMA (DMA1), SDT1)
                                If (LLess (DMA0, 0x1E))
                                {
                                    Or (ICR3, 0x02, ICR3)
                                }

                                If (LLess (DMA0, 0x3C))
                                {
                                    Or (ICR0, 0x02, ICR0)
                                }

                                If (And (W931, 0x2000))
                                {
                                    Or (ICR1, 0x02, ICR1)
                                }
                            }
                        }
                    }

                    Device (P_D0)
                    {
                        Name (_ADR, 0x00)
                        Method (_GTF, 0, NotSerialized)
                        {
                            Name (PIB0, Buffer (0x0E)
                            {
                                0x03, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x03, 
                                0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF
                            })
                            CreateByteField (PIB0, 0x01, PMD0)
                            CreateByteField (PIB0, 0x08, DMD0)
                            If (And (PRIT, 0x02))
                            {
                                If (LEqual (And (PRIT, 0x09), 0x08))
                                {
                                    Store (0x08, PMD0)
                                }
                                Else
                                {
                                    Store (0x0A, PMD0)
                                    ShiftRight (And (PRIT, 0x0300), 0x08, Local0)
                                    ShiftRight (And (PRIT, 0x3000), 0x0C, Local1)
                                    Add (Local0, Local1, Local2)
                                    If (LEqual (0x03, Local2))
                                    {
                                        Store (0x0B, PMD0)
                                    }

                                    If (LEqual (0x05, Local2))
                                    {
                                        Store (0x0C, PMD0)
                                    }
                                }
                            }
                            Else
                            {
                                Store (0x01, PMD0)
                            }

                            If (And (SYNC, 0x01))
                            {
                                Store (Or (SDT0, 0x40), DMD0)
                                If (And (ICR1, 0x01))
                                {
                                    If (And (ICR0, 0x01))
                                    {
                                        Add (DMD0, 0x02, DMD0)
                                    }

                                    If (And (ICR3, 0x01))
                                    {
                                        Store (0x45, DMD0)
                                    }
                                }
                            }
                            Else
                            {
                                Or (Subtract (And (PMD0, 0x07), 0x02), 0x20, DMD0)
                            }

                            Return (PIB0)
                        }
                    }

                    Device (P_D1)
                    {
                        Name (_ADR, 0x01)
                        Method (_GTF, 0, NotSerialized)
                        {
                            Name (PIB1, Buffer (0x0E)
                            {
                                0x03, 0x00, 0x00, 0x00, 0x00, 0xB0, 0xEF, 0x03, 
                                0x00, 0x00, 0x00, 0x00, 0xB0, 0xEF
                            })
                            CreateByteField (PIB1, 0x01, PMD1)
                            CreateByteField (PIB1, 0x08, DMD1)
                            If (And (PRIT, 0x20))
                            {
                                If (LEqual (And (PRIT, 0x90), 0x80))
                                {
                                    Store (0x08, PMD1)
                                }
                                Else
                                {
                                    Add (And (PSIT, 0x03), ShiftRight (And (PSIT, 0x0C), 0x02), Local0)
                                    If (LEqual (0x05, Local0))
                                    {
                                        Store (0x0C, PMD1)
                                    }
                                    Else
                                    {
                                        If (LEqual (0x03, Local0))
                                        {
                                            Store (0x0B, PMD1)
                                        }
                                        Else
                                        {
                                            Store (0x0A, PMD1)
                                        }
                                    }
                                }
                            }
                            Else
                            {
                                Store (0x01, PMD1)
                            }

                            If (And (SYNC, 0x02))
                            {
                                Store (Or (SDT1, 0x40), DMD1)
                                If (And (ICR1, 0x02))
                                {
                                    If (And (ICR0, 0x02))
                                    {
                                        Add (DMD1, 0x02, DMD1)
                                    }

                                    If (And (ICR3, 0x02))
                                    {
                                        Store (0x45, DMD1)
                                    }
                                }
                            }
                            Else
                            {
                                Or (Subtract (And (PMD1, 0x07), 0x02), 0x20, DMD1)
                            }

                            Return (PIB1)
                        }
                    }

                    Method (_PS0, 0, NotSerialized)
                    {
                    }

                    Method (_PS3, 0, NotSerialized)
                    {
                    }
                }

                Device (SECD)
                {
                    Name (_ADR, 0x01)
                    Method (_GTM, 0, NotSerialized)
                    {
                        Name (SBUF, Buffer (0x14)
                        {
                            0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                            0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                            0x00, 0x00, 0x00, 0x00
                        })
                        CreateDWordField (SBUF, 0x00, PIO0)
                        CreateDWordField (SBUF, 0x04, DMA0)
                        CreateDWordField (SBUF, 0x08, PIO1)
                        CreateDWordField (SBUF, 0x0C, DMA1)
                        CreateDWordField (SBUF, 0x10, FLAG)
                        Store (GETP (SECT), PIO0)
                        Store (GDMA (And (SYNC, 0x04), And (ICR3, 0x04), And (ICR0, 0x04), SDT2, And (ICR1, 0x04)), DMA0)
                        If (LEqual (DMA0, 0xFFFFFFFF))
                        {
                            Store (PIO0, DMA0)
                        }

                        If (And (SECT, 0x4000))
                        {
                            If (LEqual (And (SECT, 0x90), 0x80))
                            {
                                Store (0x0384, PIO1)
                            }
                            Else
                            {
                                Store (GETT (SSIT), PIO1)
                            }
                        }
                        Else
                        {
                            Store (0xFFFFFFFF, PIO1)
                        }

                        Store (GDMA (And (SYNC, 0x08), And (ICR3, 0x08), And (ICR0, 0x08), SDT3, And (ICR1, 0x08)), DMA1)
                        If (LEqual (DMA1, 0xFFFFFFFF))
                        {
                            Store (PIO1, DMA1)
                        }

                        Store (GETF (And (SYNC, 0x04), And (SYNC, 0x08), SECT), FLAG)
                        Return (SBUF)
                    }

                    Method (_STM, 3, NotSerialized)
                    {
                        CreateDWordField (Arg0, 0x00, PIO0)
                        CreateDWordField (Arg0, 0x04, DMA0)
                        CreateDWordField (Arg0, 0x08, PIO1)
                        CreateDWordField (Arg0, 0x0C, DMA1)
                        CreateDWordField (Arg0, 0x10, FLAG)
                        Store (0x04, ICR2)
                        If (LEqual (SizeOf (Arg1), 0x0200))
                        {
                            And (SECT, 0x40F0, SECT)
                            And (SYNC, 0x0B, SYNC)
                            Store (0x00, SDT2)
                            And (ICR0, 0x0B, ICR0)
                            And (ICR1, 0x0B, ICR1)
                            And (ICR3, 0x0B, ICR3)
                            And (ICR5, 0x0B, ICR5)
                            CreateWordField (Arg1, 0x62, W490)
                            CreateWordField (Arg1, 0x6A, W530)
                            CreateWordField (Arg1, 0x7E, W630)
                            CreateWordField (Arg1, 0x80, W640)
                            CreateWordField (Arg1, 0xB0, W880)
                            CreateWordField (Arg1, 0xBA, W930)
                            Or (SECT, 0x8004, SECT)
                            If (LAnd (And (FLAG, 0x02), And (W490, 0x0800)))
                            {
                                Or (SECT, 0x02, SECT)
                            }

                            Or (SECT, SETP (PIO0, W530, W640), SECT)
                            If (And (FLAG, 0x01))
                            {
                                Or (SYNC, 0x04, SYNC)
                                Store (SDMA (DMA0), SDT2)
                                If (LLess (DMA0, 0x1E))
                                {
                                    Or (ICR3, 0x04, ICR3)
                                }

                                If (LLess (DMA0, 0x3C))
                                {
                                    Or (ICR0, 0x04, ICR0)
                                }

                                If (And (W930, 0x2000))
                                {
                                    Or (ICR1, 0x04, ICR1)
                                }
                            }
                        }

                        If (LEqual (SizeOf (Arg2), 0x0200))
                        {
                            And (SECT, 0x3F0F, SECT)
                            Store (0x00, SSIT)
                            And (SYNC, 0x07, SYNC)
                            Store (0x00, SDT3)
                            And (ICR0, 0x07, ICR0)
                            And (ICR1, 0x07, ICR1)
                            And (ICR3, 0x07, ICR3)
                            And (ICR5, 0x07, ICR5)
                            CreateWordField (Arg2, 0x62, W491)
                            CreateWordField (Arg2, 0x6A, W531)
                            CreateWordField (Arg2, 0x7E, W631)
                            CreateWordField (Arg2, 0x80, W641)
                            CreateWordField (Arg2, 0xB0, W881)
                            CreateWordField (Arg2, 0xBA, W931)
                            Or (SECT, 0x8040, SECT)
                            If (LAnd (And (FLAG, 0x08), And (W491, 0x0800)))
                            {
                                Or (SECT, 0x20, SECT)
                            }

                            If (And (FLAG, 0x10))
                            {
                                Or (SECT, 0x4000, SECT)
                                If (LGreater (PIO1, 0xF0))
                                {
                                    Or (SECT, 0x80, SECT)
                                }
                                Else
                                {
                                    Or (SECT, 0x10, SECT)
                                    Store (SETT (PIO1, W531, W641), SSIT)
                                }
                            }

                            If (And (FLAG, 0x04))
                            {
                                Or (SYNC, 0x08, SYNC)
                                Store (SDMA (DMA1), SDT3)
                                If (LLess (DMA0, 0x1E))
                                {
                                    Or (ICR3, 0x08, ICR3)
                                }

                                If (LLess (DMA0, 0x3C))
                                {
                                    Or (ICR0, 0x08, ICR0)
                                }

                                If (And (W931, 0x2000))
                                {
                                    Or (ICR1, 0x08, ICR1)
                                }
                            }
                        }
                    }

                    Device (S_D0)
                    {
                        Name (_ADR, 0x00)
                        Method (_GTF, 0, NotSerialized)
                        {
                            Name (SIB0, Buffer (0x0E)
                            {
                                0x03, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x03, 
                                0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF
                            })
                            CreateByteField (SIB0, 0x01, PMD0)
                            CreateByteField (SIB0, 0x08, DMD0)
                            If (And (SECT, 0x02))
                            {
                                If (LEqual (And (SECT, 0x09), 0x08))
                                {
                                    Store (0x08, PMD0)
                                }
                                Else
                                {
                                    Store (0x0A, PMD0)
                                    ShiftRight (And (SECT, 0x0300), 0x08, Local0)
                                    ShiftRight (And (SECT, 0x3000), 0x0C, Local1)
                                    Add (Local0, Local1, Local2)
                                    If (LEqual (0x03, Local2))
                                    {
                                        Store (0x0B, PMD0)
                                    }

                                    If (LEqual (0x05, Local2))
                                    {
                                        Store (0x0C, PMD0)
                                    }
                                }
                            }
                            Else
                            {
                                Store (0x01, PMD0)
                            }

                            If (And (SYNC, 0x04))
                            {
                                Store (Or (SDT2, 0x40), DMD0)
                                If (And (ICR1, 0x04))
                                {
                                    If (And (ICR0, 0x04))
                                    {
                                        Add (DMD0, 0x02, DMD0)
                                    }

                                    If (And (ICR3, 0x04))
                                    {
                                        Store (0x45, DMD0)
                                    }
                                }
                            }
                            Else
                            {
                                Or (Subtract (And (PMD0, 0x07), 0x02), 0x20, DMD0)
                            }

                            Return (SIB0)
                        }
                    }

                    Device (S_D1)
                    {
                        Name (_ADR, 0x01)
                        Method (_GTF, 0, NotSerialized)
                        {
                            Name (SIB1, Buffer (0x0E)
                            {
                                0x03, 0x00, 0x00, 0x00, 0x00, 0xB0, 0xEF, 0x03, 
                                0x00, 0x00, 0x00, 0x00, 0xB0, 0xEF
                            })
                            CreateByteField (SIB1, 0x01, PMD1)
                            CreateByteField (SIB1, 0x08, DMD1)
                            If (And (SECT, 0x20))
                            {
                                If (LEqual (And (SECT, 0x90), 0x80))
                                {
                                    Store (0x08, PMD1)
                                }
                                Else
                                {
                                    Add (And (SSIT, 0x03), ShiftRight (And (SSIT, 0x0C), 0x02), Local0)
                                    If (LEqual (0x05, Local0))
                                    {
                                        Store (0x0C, PMD1)
                                    }
                                    Else
                                    {
                                        If (LEqual (0x03, Local0))
                                        {
                                            Store (0x0B, PMD1)
                                        }
                                        Else
                                        {
                                            Store (0x0A, PMD1)
                                        }
                                    }
                                }
                            }
                            Else
                            {
                                Store (0x01, PMD1)
                            }

                            If (And (SYNC, 0x08))
                            {
                                Store (Or (SDT3, 0x40), DMD1)
                                If (And (ICR1, 0x08))
                                {
                                    If (And (ICR0, 0x08))
                                    {
                                        Add (DMD1, 0x02, DMD1)
                                    }

                                    If (And (ICR3, 0x08))
                                    {
                                        Store (0x45, DMD1)
                                    }
                                }
                            }
                            Else
                            {
                                Or (Subtract (And (PMD1, 0x07), 0x02), 0x20, DMD1)
                            }

                            Return (SIB1)
                        }
                    }

                    Method (_PS0, 0, NotSerialized)
                    {
                    }

                    Method (_PS3, 0, NotSerialized)
                    {
                    }
                }

                Method (GETP, 1, NotSerialized)
                {
                    If (LEqual (And (Arg0, 0x09), 0x00))
                    {
                        Return (0xFFFFFFFF)
                    }

                    If (LEqual (And (Arg0, 0x09), 0x08))
                    {
                        Return (0x0384)
                    }

                    ShiftRight (And (Arg0, 0x0300), 0x08, Local0)
                    ShiftRight (And (Arg0, 0x3000), 0x0C, Local1)
                    Return (Multiply (0x1E, Subtract (0x09, Add (Local0, Local1))))
                }

                Method (GDMA, 5, NotSerialized)
                {
                    If (Arg0)
                    {
                        If (LAnd (Arg1, Arg4))
                        {
                            Return (0x14)
                        }

                        If (LAnd (Arg2, Arg4))
                        {
                            Return (Multiply (Subtract (0x04, Arg3), 0x0F))
                        }

                        Return (Multiply (Subtract (0x04, Arg3), 0x1E))
                    }

                    Return (0xFFFFFFFF)
                }

                Method (GETT, 1, NotSerialized)
                {
                    Return (Multiply (0x1E, Subtract (0x09, Add (And (ShiftRight (Arg0, 0x02), 0x03), And (Arg0, 0x03)))))
                }

                Method (GETF, 3, NotSerialized)
                {
                    Name (TMPF, 0x00)
                    If (Arg0)
                    {
                        Or (TMPF, 0x01, TMPF)
                    }

                    If (And (Arg2, 0x02))
                    {
                        Or (TMPF, 0x02, TMPF)
                    }

                    If (Arg1)
                    {
                        Or (TMPF, 0x04, TMPF)
                    }

                    If (And (Arg2, 0x20))
                    {
                        Or (TMPF, 0x08, TMPF)
                    }

                    If (And (Arg2, 0x4000))
                    {
                        Or (TMPF, 0x10, TMPF)
                    }

                    Return (TMPF)
                }

                Method (SETP, 3, NotSerialized)
                {
                    If (LGreater (Arg0, 0xF0))
                    {
                        Return (0x08)
                    }
                    Else
                    {
                        If (And (Arg1, 0x02))
                        {
                            If (LAnd (LNot (LGreater (Arg0, 0x78)), And (Arg2, 0x02)))
                            {
                                Return (0x2301)
                            }

                            If (LAnd (LNot (LGreater (Arg0, 0xB4)), And (Arg2, 0x01)))
                            {
                                Return (0x2101)
                            }
                        }

                        Return (0x1001)
                    }
                }

                Method (SDMA, 1, NotSerialized)
                {
                    If (LNot (LGreater (Arg0, 0x14)))
                    {
                        Return (0x01)
                    }

                    If (LNot (LGreater (Arg0, 0x1E)))
                    {
                        Return (0x02)
                    }

                    If (LNot (LGreater (Arg0, 0x2D)))
                    {
                        Return (0x01)
                    }

                    If (LNot (LGreater (Arg0, 0x3C)))
                    {
                        Return (0x02)
                    }

                    If (LNot (LGreater (Arg0, 0x5A)))
                    {
                        Return (0x01)
                    }

                    Return (0x00)
                }

                Method (SETT, 3, NotSerialized)
                {
                    If (And (Arg1, 0x02))
                    {
                        If (LAnd (LNot (LGreater (Arg0, 0x78)), And (Arg2, 0x02)))
                        {
                            Return (0x0B)
                        }

                        If (LAnd (LNot (LGreater (Arg0, 0xB4)), And (Arg2, 0x01)))
                        {
                            Return (0x09)
                        }
                    }

                    Return (0x04)
                }
            }

            Device (SBUS)
            {
                Name (_ADR, 0x001F0003)
                OperationRegion (SBUS, SystemIO, 0x1810, 0x10)
                Field (SBUS, ByteAcc, NoLock, Preserve)
                {
                    HSTS,   8, 
                    Offset (0x02), 
                    HCON,   8, 
                    HCOM,   8, 
                    TXSA,   8, 
                    DAT0,   8, 
                    DAT1,   8, 
                    BDBR,   8, 
                    Offset (0x09), 
                    RXSA,   8, 
                    SDAT,   16
                }

                Method (SBWB, 3, NotSerialized)
                {
                    While (And (HSTS, 0x01)) {}
                    Store (0x1E, HSTS)
                    Store (Arg0, TXSA)
                    Store (Arg1, HCOM)
                    Store (Arg2, DAT0)
                    Store (0x48, HCON)
                    While (LEqual (And (HSTS, 0x1E), 0x00)) {}
                    Store (0x1E, HSTS)
                }

                Method (SBRB, 2, NotSerialized)
                {
                    While (And (HSTS, 0x01)) {}
                    Store (0x1E, HSTS)
                    Store (Or (Arg0, 0x01), TXSA)
                    Store (Arg1, HCOM)
                    Store (0x48, HCON)
                    While (LEqual (And (HSTS, 0x1E), 0x00)) {}
                    Store (0x1E, HSTS)
                    Return (DAT0)
                }
            }

            Device (AUD0)
            {
                Name (_ADR, 0x001F0005)
            }

            Device (MODM)
            {
                Name (_ADR, 0x001F0006)
                Name (_PRW, Package (0x02)
                {
                    0x05, 
                    0x03
                })
            }
        }
    }
}

